/**
 * @license
 * Copyright 2020 Google LLC. All Rights Reserved.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * =============================================================================
 */
import{registerKernel as e,util as n,backend_util as t,gather_util as a,scatter_util as r,slice_util as u,buffer as s,KernelBackend as o,DataStorage as i,engine as d,registerBackend as p}from"@tensorflow/tfjs-core";import l from"fs";import c from"path";var m,f;let b;function h(t){let a;e({kernelName:t,backendName:"wasm",setupFunc:function(e){a=e.wasm.cwrap(t,null,["number","number"])},kernelFunc:function(e){const{backend:t,inputs:{x:r}}=e,u=t.dataIdMap.get(r.dataId).id,s=t.makeOutput(r.shape,r.dtype),o=t.dataIdMap.get(s.dataId).id;return 0===n.sizeFromShape(s.shape)?s:(a(u,o),s)}})}function y(a,r,u){let s;e({kernelName:a,backendName:"wasm",setupFunc:function(e){s=e.wasm.cwrap(a,null,["number","array","number","number","array","number","number","number"])},kernelFunc:function(e){const{backend:o,inputs:i}=e,{a:d,b:p}=i,l=o.dataIdMap.get(d.dataId).id,c=o.dataIdMap.get(p.dataId).id,f=null!=u?u:d.dtype,b=t.assertAndGetBroadcastShape(d.shape,p.shape),h=o.makeOutput(b,f);if(0===n.sizeFromShape(b))return h;const y=new Uint8Array(new Int32Array(d.shape).buffer),w=new Uint8Array(new Int32Array(p.shape).buffer),I=o.dataIdMap.get(h.dataId).id,g=()=>s(l,y,d.shape.length,c,w,p.shape.length,m[d.dtype],I);if(r)return g(),h;const k=t.getBroadcastDims(d.shape,b),M=t.getBroadcastDims(p.shape,b),F=k.every((e,n)=>e===n),A=M.every((e,n)=>e===n);if(F&&A)return g(),h;throw new Error("Broadcasting along outer dims is not yet "+`supported for ${a}.`)}})}!function(e){e[e.float32=0]="float32",e[e.int32=1]="int32",e[e.bool=2]="bool",e[e.string=3]="string",e[e.complex64=4]="complex64"}(m||(m={})),function(e){e[e.linear=0]="linear",e[e.relu=1]="relu",e[e.relu6=2]="relu6",e[e.prelu=3]="prelu"}(f||(f={})),e({kernelName:"_FusedMatMul",backendName:"wasm",setupFunc:function(e){b=e.wasm.cwrap("_FusedMatMul",null,["number","array","number","number","array","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{inputs:n,backend:t,attrs:a}=e,{a:r,b:u,bias:s,preluActivationWeights:o}=n;if("float32"!==r.dtype||"float32"!==u.dtype)throw new Error("_FusedMatMul for non non-float32 tensors not yet supported.");const{transposeA:i,transposeB:d,activation:p}=a,l=t.dataIdMap.get(r.dataId).id,c=t.dataIdMap.get(u.dataId).id;let m=0;if(null!=s){const e=t.dataIdMap.get(s.dataId);if(1!==e.shape.length)throw new Error("_FusedMatMul only supports rank-1 bias but got "+`rank ${e.shape.length}.`);m=e.id}const h=null==o?0:t.dataIdMap.get(o.dataId).id,y=f[p];if(null==y)throw new Error(`${p} activation not yet supported for FusedConv2D `+"in the wasm backend.");const w=i?r.shape[2]:r.shape[1],I=d?u.shape[1]:u.shape[2],g=r.shape[0],k=t.makeOutput([g,w,I],r.dtype),M=t.dataIdMap.get(k.dataId).id,F=new Uint8Array(new Int32Array(r.shape).buffer),A=new Uint8Array(new Int32Array(u.shape).buffer);return b(l,F,r.shape.length,c,A,u.shape.length,i,d,y,m,h,M),k}}),h("Abs");let w,I,g,k,M,F;function A(e){const{inputs:{x:n},attrs:{dtype:t},backend:a}=e,r=a.makeOutput(n.shape,t),u=a.typedArrayFromHeap(n);return a.typedArrayFromHeap(r).set(u),r}var v;let S,N;y("Add",!0),e({kernelName:"AddN",backendName:"wasm",setupFunc:function(e){w=e.wasm.cwrap("AddN",null,["array","number","number","number"])},kernelFunc:function(e){const{inputs:t,backend:a}=e,r=a.makeOutput(t[0].shape,t[0].dtype);if(0===n.sizeFromShape(r.shape))return r;const u=t.map(e=>a.dataIdMap.get(e.dataId).id),s=new Uint8Array(new Int32Array(u).buffer),o=a.dataIdMap.get(r.dataId).id;return w(s,u.length,m[r.dtype],o),r}}),e({kernelName:"ArgMax",backendName:"wasm",kernelFunc:function(e){const{inputs:{x:t},backend:a,attrs:{axis:r}}=e,u=t.shape.slice(0,-1),s=a.makeOutput(u,"int32"),o=a.dataIdMap.get(t.dataId).id,i=a.dataIdMap.get(s.dataId).id,d=n.sizeFromShape(s.shape),p=t.shape[r];return I(o,m[t.dtype],d,p,i),s},setupFunc:function(e){I=e.wasm.cwrap("ArgMax",null,["number","number","number","number","number"])}}),e({kernelName:"AvgPool",backendName:"wasm",setupFunc:function(e){g=e.wasm.cwrap("AvgPool",null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{inputs:n,attrs:t,backend:a}=e,r=t,{x:u}=n,s=a.dataIdMap.get(u.dataId).id,o=r.filterHeight,i=r.filterWidth,d=r.padInfo.top,p=r.padInfo.right,l=r.padInfo.bottom,c=r.padInfo.left,m=r.strideHeight,f=r.strideWidth,b=r.inChannels;if("channelsLast"!==r.dataFormat)throw new Error("wasm backend does not support dataFormat:'"+`${r.dataFormat}'. Please use 'channelsLast'.`);if(1!==r.dilationWidth||1!==r.dilationHeight)throw new Error("was backend only supports average pooling with dilation = [1, 1], "+`got [${r.dilationHeight}, ${r.dilationWidth}].`);const h=a.makeOutput(r.outShape,"float32"),y=a.dataIdMap.get(h.dataId).id;return g(s,u.shape[0],u.shape[1],u.shape[2],o,i,d,p,l,c,m,f,b,y),h}}),e({kernelName:"BatchMatMul",backendName:"wasm",setupFunc:function(e){k=e.wasm.cwrap("BatchMatMul",null,["number","array","number","number","array","number","number","number","number"])},kernelFunc:function(e){const{inputs:n,backend:t,attrs:a}=e,{a:r,b:u}=n;if("float32"!==r.dtype||"float32"!==u.dtype)throw new Error("BatchMatMul for non non-float32 tensors not yet supported.");const{transposeA:s,transposeB:o}=a,i=t.dataIdMap.get(r.dataId).id,d=t.dataIdMap.get(u.dataId).id,p=s?r.shape[2]:r.shape[1],l=o?u.shape[1]:u.shape[2],c=r.shape[0],m=t.makeOutput([c,p,l],r.dtype),f=t.dataIdMap.get(m.dataId).id,b=new Uint8Array(new Int32Array(r.shape).buffer),h=new Uint8Array(new Int32Array(u.shape).buffer);return k(i,b,r.shape.length,d,h,u.shape.length,s,o,f),m}}),e({kernelName:"Cast",backendName:"wasm",kernelFunc:A}),e({kernelName:"ClipByValue",backendName:"wasm",setupFunc:function(e){M=e.wasm.cwrap("ClipByValue",null,["number","number","number","number"])},kernelFunc:function(e){const{inputs:n,backend:t,attrs:a}=e,{x:r}=n,{min:u,max:s}=a,o=t.dataIdMap.get(r.dataId).id,i=t.makeOutput(r.shape,"float32"),d=t.dataIdMap.get(i.dataId).id;return M(o,u,s,d),i}}),e({kernelName:"Concat",backendName:"wasm",kernelFunc:function(e){const{inputs:a,backend:r,attrs:{axis:u}}=e,s=t.computeOutShape(a.map(e=>e.shape),u),o=r.makeOutput(s,a[0].dtype),i=n.sizeFromShape(a[0].shape.slice(0,u));let d=0;const p=a.map(e=>{const t=n.sizeFromShape(e.shape.slice(u));return d+=t,t}),l=a.map(e=>r.typedArrayFromHeap(e)),c=r.typedArrayFromHeap(o);for(let e=0;e<i;e++){let n=e*d;for(let t=0;t<l.length;t++){const a=p[t],r=e*a,u=l[t].subarray(r,r+a);c.set(u,n),n+=a}}return o}}),e({kernelName:"Conv2D",backendName:"wasm",setupFunc:function(e){F=e.wasm.cwrap("Conv2D",null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{inputs:n,attrs:t,backend:a}=e,r=t,{x:u,filter:s}=n,o=a.dataIdMap.get(u.dataId).id,i=a.dataIdMap.get(s.dataId).id,d=r.filterHeight,p=r.filterWidth,l=r.padInfo.top,c=r.padInfo.right,m=r.padInfo.bottom,f=r.padInfo.left,b=r.dilationHeight,h=r.dilationWidth,y=r.strideHeight,w=r.strideWidth,I=r.inChannels,g=r.outChannels,k="SAME"===r.padInfo.type?1:0;if("channelsLast"!==r.dataFormat)throw new Error("wasm backend Conv2D does not support dataFormat:'"+`${r.dataFormat}'. Please use 'channelsLast'.`);const M=a.makeOutput(r.outShape,"float32"),A=a.dataIdMap.get(M.dataId).id;return F(o,u.shape[0],u.shape[1],u.shape[2],i,d,p,l,c,m,f,k,b,h,y,w,I,g,A),M}}),h("Cos"),function(e){e[e.bilinear=0]="bilinear",e[e.nearest=1]="nearest"}(v||(v={})),e({kernelName:"CropAndResize",backendName:"wasm",setupFunc:function(e){S=e.wasm.cwrap("CropAndResize",null,["number","number","number","number","array","number","number","number","number","number"])},kernelFunc:function(e){const{backend:n,inputs:t,attrs:a}=e,{method:r,extrapolationValue:u,cropSize:s}=a,{images:o,boxes:i,boxInd:d}=t,p=i.shape[0],[l,c]=s,m=[p,l,c,o.shape[3]];let f,b=n.dataIdMap.get(o.dataId);"float32"!==o.dtype&&(f=A({backend:n,inputs:{x:o},attrs:{dtype:"float32"}}),b=n.dataIdMap.get(f.dataId));const h=b.id,y=n.dataIdMap.get(i.dataId).id,w=n.dataIdMap.get(d.dataId).id,I=n.makeOutput(m,"float32"),g=n.dataIdMap.get(I.dataId).id,k=new Uint8Array(new Int32Array(o.shape).buffer);return S(h,y,w,p,k,l,c,v[r],u,g),null!=f&&n.disposeData(f.dataId),I}}),e({kernelName:"DepthwiseConv2dNative",backendName:"wasm",setupFunc:function(e){N=e.wasm.cwrap("DepthwiseConv2dNative",null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{inputs:n,attrs:t,backend:a}=e,r=t,{x:u,filter:s}=n,o=a.dataIdMap.get(u.dataId).id,i=a.dataIdMap.get(s.dataId).id,d=r.filterHeight,p=r.filterWidth,l=r.padInfo.top,c=r.padInfo.right,m=r.padInfo.bottom,f=r.padInfo.left,b=r.dilationHeight,h=r.dilationWidth,y=r.strideHeight,w=r.strideWidth,I=r.inChannels,g=r.outChannels,k="SAME"===r.padInfo.type?1:0;if("channelsLast"!==r.dataFormat)throw new Error("wasm backend DepthwiseConv2dNative does not support dataFormat:'"+`${r.dataFormat}'. Please use 'channelsLast'.`);const M=a.makeOutput(r.outShape,"float32"),F=a.dataIdMap.get(M.dataId).id;return N(o,u.shape[0],u.shape[1],u.shape[2],i,d,p,l,c,m,f,k,b,h,y,w,I,g,F),M}});y("Div",!1),h("Exp");let x,_,E,C,O;y("FloorDiv",!1),e({kernelName:"FusedBatchNorm",backendName:"wasm",setupFunc:function(e){x=e.wasm.cwrap("FusedBatchNorm",null,["number","number","number","number","number","number","number"])},kernelFunc:function(e){const{backend:t,inputs:a,attrs:r}=e,{varianceEpsilon:u}=r,{x:s,mean:o,variance:i,offset:d,scale:p}=a,l=t.dataIdMap.get(s.dataId).id,c=t.dataIdMap.get(o.dataId).id,m=t.dataIdMap.get(i.dataId).id,f=null!=d?t.dataIdMap.get(d.dataId).id:0,b=null!=p?t.dataIdMap.get(p.dataId).id:0,h=t.makeOutput(s.shape,s.dtype);if(0===n.sizeFromShape(s.shape))return h;const y=t.dataIdMap.get(h.dataId).id;return x(l,c,m,f,b,u,y),h}}),e({kernelName:"FusedConv2D",backendName:"wasm",setupFunc:function(e){_=e.wasm.cwrap("FusedConv2D",null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{inputs:n,attrs:t,backend:a}=e,{convInfo:r,activation:u}=t,s=f[u];if(null==s)throw new Error(`${u} activation not yet supported for FusedConv2D `+"in the wasm backend.");const{x:o,filter:i,bias:d,preluActivationWeights:p}=n,l=a.dataIdMap.get(o.dataId).id,c=a.dataIdMap.get(i.dataId).id,m=r.outChannels;let b=0;if(null!=d){const e=a.dataIdMap.get(d.dataId);if(1!==e.shape.length)throw new Error("FusedConv2D only supports rank-1 bias but got "+`rank ${e.shape.length}.`);if(e.shape[0]!==m)throw new Error(`FusedConv2D bias shape (${e.shape}) does not `+`match the number of output channels (${m})`);b=e.id}const h=r.filterHeight,y=r.filterWidth,w=r.padInfo.top,I=r.padInfo.right,g=r.padInfo.bottom,k=r.padInfo.left,M=r.dilationHeight,F=r.dilationWidth,A=r.strideHeight,v=r.strideWidth,S=r.inChannels,N="SAME"===r.padInfo.type?1:0,x=r.batchSize,E=r.inHeight,C=r.inWidth;if("channelsLast"!==r.dataFormat)throw new Error("wasm backend FusedConv2D does not support dataFormat:'"+`${r.dataFormat}'. Please use 'channelsLast'.`);const O=a.makeOutput(r.outShape,"float32"),D=a.dataIdMap.get(O.dataId).id,z=null==p?0:a.dataIdMap.get(p.dataId).id;return _(l,x,E,C,c,h,y,b,w,I,g,k,N,M,F,A,v,S,m,s,z,D),O}}),e({kernelName:"FusedDepthwiseConv2D",backendName:"wasm",setupFunc:function(e){E=e.wasm.cwrap("FusedDepthwiseConv2D",null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{inputs:n,attrs:t,backend:a}=e,{convInfo:r,activation:u}=t,s=f[u];if(null==s)throw new Error(`${u} activation not yet supported for FusedDepthwiseConv2D `+"in the wasm backend.");const{x:o,filter:i,bias:d,preluActivationWeights:p}=n,l=a.dataIdMap.get(o.dataId).id,c=a.dataIdMap.get(i.dataId).id,m=r.outChannels;let b=0;if(null!=d){const e=a.dataIdMap.get(d.dataId);if(1!==e.shape.length)throw new Error("FusedDepthwiseConv2D only supports rank-1 bias but got "+`rank ${e.shape.length}.`);if(e.shape[0]!==m)throw new Error(`FusedDepthwiseConv2D bias shape (${e.shape}) does not `+`match the number of output channels (${m})`);b=e.id}const h=r.filterHeight,y=r.filterWidth,w=r.padInfo.top,I=r.padInfo.right,g=r.padInfo.bottom,k=r.padInfo.left,M=r.dilationHeight,F=r.dilationWidth,A=r.strideHeight,v=r.strideWidth,S=r.inChannels,N="SAME"===r.padInfo.type?1:0,x=r.batchSize,_=r.inHeight,C=r.inWidth;if("channelsLast"!==r.dataFormat)throw new Error("wasm backend FusedDepthwiseConv2D does not support dataFormat:'"+`${r.dataFormat}'. Please use 'channelsLast'.`);const O=a.makeOutput(r.outShape,"float32"),D=a.dataIdMap.get(O.dataId).id,z=null==p?0:a.dataIdMap.get(p.dataId).id;return E(l,x,_,C,c,h,y,b,w,I,g,k,N,M,F,A,v,S,m,s,z,D),O}}),e({kernelName:"Gather",backendName:"wasm",setupFunc:function(e){C=e.wasm.cwrap("Gather",null,["number","number","array","number","number","number","array","number"])},kernelFunc:function(e){const{backend:t,inputs:a,attrs:r}=e,{x:u,indices:s}=a,{axis:o}=r,i=u.shape.slice();i[o]=n.sizeFromShape(s.shape);const d=u.shape.length-1,p=t.makeOutput(i,u.dtype);if(0===n.sizeFromShape(u.shape))return p;const l=t.dataIdMap.get(u.dataId).id,c=t.dataIdMap.get(s.dataId).id,f=t.dataIdMap.get(p.dataId).id,b=new Uint8Array(new Int32Array(n.computeStrides(u.shape)).buffer),h=new Uint8Array(new Int32Array(n.computeStrides(i)).buffer);return C(l,m[u.dtype],b,d,c,o,h,f),p}}),e({kernelName:"GatherNd",backendName:"wasm",setupFunc:function(e){O=e.wasm.cwrap("GatherNd",null,["number","number","number","number","number","number","array","number"])},kernelFunc:function(e){const{backend:n,inputs:t}=e,{x:r,indices:u}=t,[s,o,i,d]=a.prepareAndValidate(r,u),p=n.makeOutput(s,r.dtype);if(0===o)return p;const l=u.shape,c=l[l.length-1],f=n.dataIdMap.get(r.dataId).id,b=n.dataIdMap.get(u.dataId).id,h=new Uint8Array(new Int32Array(d).buffer),y=n.dataIdMap.get(p.dataId).id;return O(f,m[r.dtype],b,o,c,i,h,y),p}});y("Greater",!1,"bool");y("GreaterEqual",!1,"bool");y("Less",!1,"bool");y("LessEqual",!1,"bool"),h("Log");let D;y("LogicalAnd",!1,"bool"),e({kernelName:"Max",backendName:"wasm",setupFunc:function(e){D=e.wasm.cwrap("Max",null,["number, number, number"])},kernelFunc:function(e){const{backend:a,inputs:r,attrs:u}=e,{axes:s}=u,{x:o}=r,i=a.dataIdMap.get(o.dataId).id;t.assertAxesAreInnerMostDims("max",s,o.shape.length);const[d,p]=t.computeOutAndReduceShapes(o.shape,s),l=n.sizeFromShape(p),c=a.makeOutput(d,o.dtype);if(0===n.sizeFromShape(o.shape))return c;const m=a.dataIdMap.get(c.dataId).id;return D(i,l,m),c}});let z,R;y("Maximum",!1),e({kernelName:"MaxPool",backendName:"wasm",setupFunc:function(e){z=e.wasm.cwrap("MaxPool",null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{inputs:n,attrs:t,backend:a}=e,r=t,{x:u}=n,s=a.dataIdMap.get(u.dataId).id,o=r.filterHeight,i=r.filterWidth,d=r.padInfo.top,p=r.padInfo.right,l=r.padInfo.bottom,c=r.padInfo.left,m=r.dilationHeight,f=r.dilationWidth,b=r.strideHeight,h=r.strideWidth,y=r.inChannels,w=r.outChannels;if("channelsLast"!==r.dataFormat)throw new Error("wasm backend does not support dataFormat:'"+`${r.dataFormat}'. Please use 'channelsLast'.`);const I=a.makeOutput(r.outShape,"float32"),g=a.dataIdMap.get(I.dataId).id;return z(s,u.shape[0],u.shape[1],u.shape[2],o,i,d,p,l,c,m,f,b,h,y,w,g),I}}),e({kernelName:"Min",backendName:"wasm",setupFunc:function(e){R=e.wasm.cwrap("Min",null,["number, number, number"])},kernelFunc:function(e){const{backend:a,inputs:r,attrs:u}=e,{axes:s}=u,{x:o}=r,i=a.dataIdMap.get(o.dataId).id;t.assertAxesAreInnerMostDims("min",s,o.shape.length);const[d,p]=t.computeOutAndReduceShapes(o.shape,s),l=n.sizeFromShape(p),c=a.makeOutput(d,o.dtype);if(0===n.sizeFromShape(o.shape))return c;const m=a.dataIdMap.get(c.dataId).id;return R(i,l,m),c}});y("Minimum",!1);function H(e,n){const t=new Int32Array(e.wasm.HEAPU8.buffer,n,3),a=t[0],r=t[1],u=t[2];return e.wasm._free(n),{pSelectedIndices:a,selectedSize:r,pSelectedScores:u}}let P,W;y("Mul",!0),h("Neg"),e({kernelName:"NonMaxSuppressionV3",backendName:"wasm",setupFunc:function(e){P=e.wasm.cwrap("NonMaxSuppressionV3","number",["number","number","number","number","number"])},kernelFunc:function(e){const{backend:n,inputs:t,attrs:a}=e,{iouThreshold:r,maxOutputSize:u,scoreThreshold:s}=a,{boxes:o,scores:i}=t,d=n.dataIdMap.get(o.dataId).id,p=n.dataIdMap.get(i.dataId).id,l=P(d,p,u,r,s),{pSelectedIndices:c,selectedSize:m,pSelectedScores:f}=H(n,l);return n.wasm._free(f),n.makeOutput([m],"int32",c)}}),e({kernelName:"NonMaxSuppressionV5",backendName:"wasm",setupFunc:function(e){W=e.wasm.cwrap("NonMaxSuppressionV5","number",["number","number","number","number","number","number"])},kernelFunc:function(e){const{backend:n,inputs:t,attrs:a}=e,{iouThreshold:r,maxOutputSize:u,scoreThreshold:s,softNmsSigma:o}=a,{boxes:i,scores:d}=t,p=n.dataIdMap.get(i.dataId).id,l=n.dataIdMap.get(d.dataId).id,c=W(p,l,u,r,s,o),{pSelectedIndices:m,selectedSize:f,pSelectedScores:b}=H(n,c);return[n.makeOutput([f],"int32",m),n.makeOutput([f],"float32",b)]}});let U;y("NotEqual",!1,"bool"),e({kernelName:"OnesLike",backendName:"wasm",kernelFunc:function(e){const{inputs:{x:n},backend:t}=e,a=t.makeOutput(n.shape,n.dtype);return t.typedArrayFromHeap(a).fill(1),a}}),e({kernelName:"PadV2",backendName:"wasm",kernelFunc:function(e){const{inputs:{x:n},backend:t,attrs:{paddings:a,constantValue:r}}=e,u=a.map((e,t)=>e[0]+n.shape[t]+e[1]),s=t.dataIdMap.get(n.dataId).id,o=t.makeOutput(u,n.dtype),i=t.dataIdMap.get(o.dataId).id,d=new Uint8Array(new Int32Array(n.shape).buffer),p=[].concat(...a),l=new Uint8Array(new Int32Array(p).buffer);return U(s,d,n.shape.length,m[n.dtype],l,r,i),o},setupFunc:function(e){U=e.wasm.cwrap("PadV2",null,["number","array","number","number","array","number","number"])}});let T,B,L,$,j;function q(e){const{inputs:{x:t},attrs:{begin:a,size:r},backend:o}=e,i=u.isSliceContinous(t.shape,a,r),d=o.typedArrayFromHeap(t),p=o.makeOutput(r,t.dtype),l=o.typedArrayFromHeap(p),c=n.computeStrides(t.shape);if(i){const e=u.computeFlatOffset(a,c);return l.set(d.subarray(e,e+n.sizeFromShape(r))),p}const m=t.shape.length;return 2===m?function(e,n,t,a,r){let u=0;const s=a[0],o=a[1],i=s+r[0];for(let a=s;a<i;a++){const s=a*n+o;t.set(e.subarray(s,s+r[1]),u),u+=r[1]}}(d,c[0],l,a,r):3===m?function(e,n,t,a,r,u){let s=0;const o=r[0],i=r[1],d=r[2],p=o+u[0],l=i+u[1];for(let r=o;r<p;r++)for(let o=i;o<l;o++){const i=r*n+o*t+d;a.set(e.subarray(i,i+u[2]),s),s+=u[2]}}(d,c[0],c[1],l,a,r):4===m?function(e,n,t,a,r,u,s){let o=0;const i=u[0],d=u[1],p=u[2],l=i+s[0],c=d+s[1],m=p+s[2],f=u[3];for(let u=i;u<l;u++)for(let i=d;i<c;i++)for(let d=p;d<m;d++){const p=u*n+i*t+d*a+f;r.set(e.subarray(p,p+s[3]),o),o+=s[3]}}(d,c[0],c[1],c[2],l,a,r):function(e,n,t,a,r){const u=s(r,n.dtype,t),o=s(n.shape,n.dtype,e);for(let e=0;e<u.size;++e){const n=u.indexToLoc(e).map((e,n)=>e+a[n]);t[e]=o.get(...n)}}(d,t,l,a,r),p}y("Pow",!1),e({kernelName:"Prelu",backendName:"wasm",setupFunc:function(e){T=e.wasm.cwrap("Prelu",null,["number","number","number"])},kernelFunc:function(e){const{inputs:n,backend:t}=e,{x:a,alpha:r}=n,u=t.dataIdMap.get(a.dataId).id,s=t.dataIdMap.get(r.dataId).id,o=t.makeOutput(a.shape,"float32"),i=t.dataIdMap.get(o.dataId).id;return T(u,s,i),o}}),h("Relu"),h("Relu6"),e({kernelName:"Reshape",backendName:"wasm",kernelFunc:function(e){const{inputs:{x:n},attrs:{shape:t}}=e;return{dataId:n.dataId,shape:t,dtype:n.dtype}}}),e({kernelName:"ResizeBilinear",backendName:"wasm",setupFunc:function(e){B=e.wasm.cwrap("ResizeBilinear",null,["number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{backend:t,inputs:a,attrs:r}=e,{x:u}=a,{alignCorners:s,newHeight:o,newWidth:i}=r,[d,p,l,c]=u.shape,m=[d,o,i,c];let f,b=t.dataIdMap.get(u.dataId);"float32"!==b.dtype&&(f=A({backend:t,inputs:{x:u},attrs:{dtype:"float32"}}),b=t.dataIdMap.get(f.dataId));const h=b.id,y=t.makeOutput(m,"float32");if(0===n.sizeFromShape(u.shape))return y;const w=t.dataIdMap.get(y.dataId).id;return B(h,d,p,l,c,o,i,s?1:0,w),null!=f&&t.disposeData(f.dataId),y}}),h("Rsqrt"),e({kernelName:"ScatterNd",backendName:"wasm",setupFunc:function(e){L=e.wasm.cwrap("ScatterNd",null,["number","number","number","number","number","number","array","number","number"])},kernelFunc:function(e){const{backend:t,inputs:a,attrs:u}=e,{indices:s,updates:o}=a,{shape:i}=u,d=t.makeOutput(i,o.dtype);if(0===n.sizeFromShape(i))return d;const{sliceRank:p,numUpdates:l,sliceSize:c,strides:f,outputSize:b}=r.calculateShapes(o,s,i),h=t.dataIdMap.get(s.dataId).id,y=t.dataIdMap.get(o.dataId).id,w=new Uint8Array(new Int32Array(f).buffer),I=t.dataIdMap.get(d.dataId).id;return L(h,y,m[o.dtype],p,l,c,w,b,I),d}}),e({kernelName:"Sigmoid",backendName:"wasm",setupFunc:function(e){$=e.wasm.cwrap("Sigmoid",null,["number","number"])},kernelFunc:function(e){const{backend:t,inputs:{x:a}}=e,r=t.dataIdMap.get(a.dataId).id,u=t.makeOutput(a.shape,a.dtype),s=t.dataIdMap.get(u.dataId).id;return 0===n.sizeFromShape(u.shape)?u:($(r,s),u)}}),h("Sin"),e({kernelName:"Slice",backendName:"wasm",kernelFunc:q}),e({kernelName:"Softmax",backendName:"wasm",setupFunc:function(e){j=e.wasm.cwrap("Softmax",null,["number","number","number","number"])},kernelFunc:function(e){const{backend:t,inputs:{logits:a},attrs:{dim:r}}=e,u=t.dataIdMap.get(a.dataId).id,s=t.makeOutput(a.shape,a.dtype),o=t.dataIdMap.get(s.dataId).id,i=a.shape[r],d=n.sizeFromShape(a.shape)/i;return 0===n.sizeFromShape(s.shape)?s:(j(u,o,i,d),s)}}),h("Square");let V,G,X;y("Sub",!0),e({kernelName:"Sum",backendName:"wasm",setupFunc:function(e){V=e.wasm.cwrap("Sum",null,["number, number, number"])},kernelFunc:function(e){const{backend:a,inputs:r,attrs:u}=e,{axes:s}=u,{x:o}=r,i=a.dataIdMap.get(o.dataId).id;t.assertAxesAreInnerMostDims("sum",s,o.shape.length);const[d,p]=t.computeOutAndReduceShapes(o.shape,s),l=n.sizeFromShape(p),c=a.makeOutput(d,o.dtype);if(0===n.sizeFromShape(o.shape))return c;const m=a.dataIdMap.get(c.dataId).id;return V(i,l,m),c}}),h("Tanh"),e({kernelName:"Tile",backendName:"wasm",setupFunc:function(e){G=e.wasm.cwrap("Tile",null,["number","array","number","array","number","number"])},kernelFunc:function(e){const{inputs:n,backend:t,attrs:a}=e,{x:r}=n,u=t.dataIdMap.get(r.dataId).id,{reps:s}=a,o=new Array(r.shape.length);for(let e=0;e<o.length;e++)o[e]=r.shape[e]*s[e];const i=new Uint8Array(new Int32Array(r.shape).buffer),d=new Uint8Array(new Int32Array(o).buffer),p=t.makeOutput(o,r.dtype),l=t.dataIdMap.get(p.dataId).id;return G(u,i,r.shape.length,d,o.length,m[p.dtype],l),p}}),e({kernelName:"Transpose",backendName:"wasm",kernelFunc:function(e){const{inputs:n,backend:t,attrs:a}=e,[r,u]=function(e,n){const t=[],a=[];for(let r=0;r<e.length;++r)1!==e[r]&&t.push(e[r]),1!==e[n[r]]&&a.push(n[r]);for(let e=0;e<a.length;++e){let n=-1;for(let t=0;t<a.length;++t)a[t]>=e&&(-1===n||a[n]>a[t])&&(n=t);a[n]=e}return[t,a]}(n.x.shape,a.perm),s={dataId:n.x.dataId,shape:r,dtype:n.x.dtype};let o=!0;for(let e=0;e<u.length;e++)u[e]!==e&&(o=!1);const i=function(e,n){const t=new Array(e.length);for(let a=0;a<t.length;a++)t[a]=e[n[a]];return t}(n.x.shape,a.perm);if(o)return{dataId:s.dataId,shape:i,dtype:s.dtype};const d=t.makeOutput(i,s.dtype),p=t.dataIdMap.get(s.dataId).id,l=t.dataIdMap.get(d.dataId).id,c=new Uint8Array(new Int32Array(u).buffer),f=new Uint8Array(new Int32Array(s.shape).buffer);return X(p,f,s.shape.length,m[s.dtype],l,c,u.length),d},setupFunc:function(e){X=e.wasm.cwrap("Transpose",null,["number","array","number","number","number","array","number"])}}),e({kernelName:"Unpack",backendName:"wasm",kernelFunc:function(e){const{inputs:{x:n},backend:t,attrs:{axis:a}}=e,r=n.shape[a],u=n.shape.length,s=new Array(u-1);let o=0;for(let e=0;e<u;e++)e!==a&&(s[o++]=n.shape[e]);const i=new Array(r),d=new Array(u).fill(0),p=n.shape.slice();p[a]=1;for(let e=0;e<i.length;e++)d[a]=e,i[e]=q({inputs:{x:n},attrs:{begin:d,size:p},backend:t});return i.map(({dataId:e,dtype:n})=>({dataId:e,dtype:n,shape:s}))}}),e({kernelName:"ZerosLike",backendName:"wasm",kernelFunc:function(e){const{inputs:{x:n},backend:t}=e,a=t.makeOutput(n.shape,n.dtype);return t.typedArrayFromHeap(a).fill(0),a}});var Z=function(e,n){return e(n={exports:{}},n.exports),n.exports}((function(e,n){var t,a=(t="undefined"!=typeof document&&document.currentScript?document.currentScript.src:void 0,function(e){var n,a=void 0!==(e=e||{})?e:{},r={};for(n in a)a.hasOwnProperty(n)&&(r[n]=a[n]);var u=!1,s=!1,o=!1,i=!1;u="object"==typeof window,s="function"==typeof importScripts,o="object"==typeof process&&"object"==typeof process.versions&&"string"==typeof process.versions.node&&!u&&!s,i=!u&&!o&&!s;var d,p,m,f,b="";function h(e){return a.locateFile?a.locateFile(e,b):b+e}o?(b=__dirname+"/",d=function(e,n){var t;return m||(m=l),f||(f=c),e=f.normalize(e),t=m.readFileSync(e),n?t:t.toString()},p=function(e){var n=d(e,!0);return n.buffer||(n=new Uint8Array(n)),F(n.buffer),n},process.argv.length>1&&process.argv[1].replace(/\\/g,"/"),process.argv.slice(2),process.on("uncaughtException",(function(e){if(!(e instanceof Ce))throw e})),process.on("unhandledRejection",oe),a.inspect=function(){return"[Emscripten Module object]"}):i?("undefined"!=typeof read&&(d=function(e){return read(e)}),p=function(e){var n;return"function"==typeof readbuffer?new Uint8Array(readbuffer(e)):(F("object"==typeof(n=read(e,"binary"))),n)},"undefined"!=typeof scriptArgs&&scriptArgs,"undefined"!=typeof print&&("undefined"==typeof console&&(console={}),console.log=print,console.warn=console.error="undefined"!=typeof printErr?printErr:print)):(u||s)&&(s?b=self.location.href:document.currentScript&&(b=document.currentScript.src),t&&(b=t),b=0!==b.indexOf("blob:")?b.substr(0,b.lastIndexOf("/")+1):"",d=function(e){var n=new XMLHttpRequest;return n.open("GET",e,!1),n.send(null),n.responseText},s&&(p=function(e){var n=new XMLHttpRequest;return n.open("GET",e,!1),n.responseType="arraybuffer",n.send(null),new Uint8Array(n.response)}));var y,w,I=a.print||console.log.bind(console),g=a.printErr||console.warn.bind(console);for(n in r)r.hasOwnProperty(n)&&(a[n]=r[n]);r=null,a.arguments&&a.arguments,a.thisProgram&&a.thisProgram,a.quit&&a.quit,a.wasmBinary&&(y=a.wasmBinary),a.noExitRuntime&&a.noExitRuntime,"object"!=typeof WebAssembly&&g("no native wasm support detected");var k=new WebAssembly.Table({initial:112,maximum:112,element:"anyfunc"}),M=!1;function F(e,n){e||oe("Assertion failed: "+n)}function A(e){var n=a["_"+e];return F(n,"Cannot call unknown function "+e+", make sure it is exported"),n}function v(e,n,t,a,r){var u={string:function(e){var n=0;if(null!=e&&0!==e){var t=1+(e.length<<2);C(e,n=_e(t),t)}return n},array:function(e){var n=_e(e.length);return O(e,n),n}},s=A(e),o=[],i=0;if(a)for(var d=0;d<a.length;d++){var p=u[t[d]];p?(0===i&&(i=xe()),o[d]=p(a[d])):o[d]=a[d]}var l=s.apply(null,o);return l=function(e){return"string"===n?_(e):"boolean"===n?Boolean(e):e}(l),0!==i&&Ee(i),l}function S(e,n,t,a){var r=(t=t||[]).every((function(e){return"number"===e}));return"string"!==n&&r&&!a?A(e):function(){return v(e,n,t,arguments)}}var N="undefined"!=typeof TextDecoder?new TextDecoder("utf8"):void 0;function x(e,n,t){for(var a=n+t,r=n;e[r]&&!(r>=a);)++r;if(r-n>16&&e.subarray&&N)return N.decode(e.subarray(n,r));for(var u="";n<r;){var s=e[n++];if(128&s){var o=63&e[n++];if(192!=(224&s)){var i=63&e[n++];if((s=224==(240&s)?(15&s)<<12|o<<6|i:(7&s)<<18|o<<12|i<<6|63&e[n++])<65536)u+=String.fromCharCode(s);else{var d=s-65536;u+=String.fromCharCode(55296|d>>10,56320|1023&d)}}else u+=String.fromCharCode((31&s)<<6|o)}else u+=String.fromCharCode(s)}return u}function _(e,n){return e?x(R,e,n):""}function E(e,n,t,a){if(!(a>0))return 0;for(var r=t,u=t+a-1,s=0;s<e.length;++s){var o=e.charCodeAt(s);if(o>=55296&&o<=57343&&(o=65536+((1023&o)<<10)|1023&e.charCodeAt(++s)),o<=127){if(t>=u)break;n[t++]=o}else if(o<=2047){if(t+1>=u)break;n[t++]=192|o>>6,n[t++]=128|63&o}else if(o<=65535){if(t+2>=u)break;n[t++]=224|o>>12,n[t++]=128|o>>6&63,n[t++]=128|63&o}else{if(t+3>=u)break;n[t++]=240|o>>18,n[t++]=128|o>>12&63,n[t++]=128|o>>6&63,n[t++]=128|63&o}}return n[t]=0,t-r}function C(e,n,t){return E(e,R,n,t)}function O(e,n){z.set(e,n)}"undefined"!=typeof TextDecoder&&new TextDecoder("utf-16le");var D,z,R,H,P=65536;function W(e,n){return e%n>0&&(e+=n-e%n),e}function U(e){D=e,a.HEAP8=z=new Int8Array(e),a.HEAP16=new Int16Array(e),a.HEAP32=H=new Int32Array(e),a.HEAPU8=R=new Uint8Array(e),a.HEAPU16=new Uint16Array(e),a.HEAPU32=new Uint32Array(e),a.HEAPF32=new Float32Array(e),a.HEAPF64=new Float64Array(e)}var T=5253200,B=10160,L=a.TOTAL_MEMORY||16777216;function $(e){for(;e.length>0;){var n=e.shift();if("function"!=typeof n){var t=n.func;"number"==typeof t?void 0===n.arg?a.dynCall_v(t):a.dynCall_vi(t,n.arg):t(void 0===n.arg?null:n.arg)}else n()}}(w=a.wasmMemory?a.wasmMemory:new WebAssembly.Memory({initial:L/P}))&&(D=w.buffer),L=D.byteLength,U(D),H[B>>2]=T;var j=[],q=[],V=[],G=[];function X(){if(a.preRun)for("function"==typeof a.preRun&&(a.preRun=[a.preRun]);a.preRun.length;)K(a.preRun.shift());$(j)}function Z(){$(q)}function Y(){$(V)}function J(){if(a.postRun)for("function"==typeof a.postRun&&(a.postRun=[a.postRun]);a.postRun.length;)Q(a.postRun.shift());$(G)}function K(e){j.unshift(e)}function Q(e){G.unshift(e)}var ee=Math.ceil,ne=Math.floor,te=0,ae=null,re=null;function ue(e){te++,a.monitorRunDependencies&&a.monitorRunDependencies(te)}function se(e){if(te--,a.monitorRunDependencies&&a.monitorRunDependencies(te),0==te&&(null!==ae&&(clearInterval(ae),ae=null),re)){var n=re;re=null,n()}}function oe(e){throw a.onAbort&&a.onAbort(e),I(e+=""),g(e),M=!0,e="abort("+e+"). Build with -s ASSERTIONS=1 for more info.",new WebAssembly.RuntimeError(e)}a.preloadedImages={},a.preloadedAudios={};var ie="data:application/octet-stream;base64,";function de(e){return String.prototype.startsWith?e.startsWith(ie):0===e.indexOf(ie)}var pe="tfjs-backend-wasm.wasm";function le(){try{if(y)return new Uint8Array(y);if(p)return p(pe);throw"both async and sync fetching of the wasm failed"}catch(e){oe(e)}}function ce(){return y||!u&&!s||"function"!=typeof fetch?new Promise((function(e,n){e(le())})):fetch(pe,{credentials:"same-origin"}).then((function(e){if(!e.ok)throw"failed to load wasm binary file at '"+pe+"'";return e.arrayBuffer()})).catch((function(){return le()}))}function me(){var e={env:Ae,wasi_unstable:Ae};function n(e,n){var t=e.exports;a.asm=t,se()}function t(e){n(e.instance)}function r(n){return ce().then((function(n){return WebAssembly.instantiate(n,e)})).then(n,(function(e){g("failed to asynchronously prepare wasm: "+e),oe(e)}))}if(ue(),a.instantiateWasm)try{return a.instantiateWasm(e,n)}catch(e){return g("Module.instantiateWasm callback failed with error: "+e),!1}return function(){if(y||"function"!=typeof WebAssembly.instantiateStreaming||de(pe)||"function"!=typeof fetch)return r(t);fetch(pe,{credentials:"same-origin"}).then((function(n){return WebAssembly.instantiateStreaming(n,e).then(t,(function(e){g("wasm streaming compile failed: "+e),g("falling back to ArrayBuffer instantiation"),r(t)}))}))}(),{}}function fe(){oe()}function be(e,n,t){R.set(R.subarray(n,n+t),e)}function he(){return z.length}function ye(e){try{return w.grow(e-D.byteLength+65535>>16),U(w.buffer),1}catch(e){}}function we(e){var n=he();if(e>2147418112)return!1;for(var t=Math.max(n,16777216);t<e;)t=t<=536870912?W(2*t,65536):Math.min(W((3*t+2147483648)/4,65536),2147418112);return!!ye(t)}de(pe)||(pe=h(pe)),q.push({func:function(){Ne()}});var Ie={buffers:[null,[],[]],printChar:function(e,n){var t=Ie.buffers[e];0===n||10===n?((1===e?I:g)(x(t,0)),t.length=0):t.push(n)},varargs:0,get:function(e){return Ie.varargs+=4,H[Ie.varargs-4>>2]},getStr:function(){return _(Ie.get())},get64:function(){var e=Ie.get();return Ie.get(),e},getZero:function(){Ie.get()}};function ge(e){try{return 0}catch(e){return"undefined"!=typeof FS&&e instanceof FS.ErrnoError||oe(e),e.errno}}function ke(e,n,t,a,r){try{return 0}catch(e){return"undefined"!=typeof FS&&e instanceof FS.ErrnoError||oe(e),e.errno}}function Me(e,n,t,a){try{for(var r=0,u=0;u<t;u++){for(var s=H[n+8*u>>2],o=H[n+(8*u+4)>>2],i=0;i<o;i++)Ie.printChar(e,R[s+i]);r+=o}return H[a>>2]=r,0}catch(e){return"undefined"!=typeof FS&&e instanceof FS.ErrnoError||oe(e),e.errno}}function Fe(e){return(e=+e)>=0?+ne(e+.5):+ee(e-.5)}var Ae={a:fe,d:be,e:we,g:ge,c:ke,f:Me,memory:w,b:Fe,table:k},ve=me();a.asm=ve;var Se,Ne=a.___wasm_call_ctors=function(){return a.asm.h.apply(null,arguments)},xe=(a._init=function(){return a.asm.i.apply(null,arguments)},a._register_tensor=function(){return a.asm.j.apply(null,arguments)},a._dispose_data=function(){return a.asm.k.apply(null,arguments)},a._dispose=function(){return a.asm.l.apply(null,arguments)},a._Abs=function(){return a.asm.m.apply(null,arguments)},a._Add=function(){return a.asm.n.apply(null,arguments)},a._AddN=function(){return a.asm.o.apply(null,arguments)},a._ArgMax=function(){return a.asm.p.apply(null,arguments)},a._AvgPool=function(){return a.asm.q.apply(null,arguments)},a._BatchMatMul=function(){return a.asm.r.apply(null,arguments)},a._ClipByValue=function(){return a.asm.s.apply(null,arguments)},a._Conv2D=function(){return a.asm.t.apply(null,arguments)},a._Cos=function(){return a.asm.u.apply(null,arguments)},a._CropAndResize=function(){return a.asm.v.apply(null,arguments)},a._DepthwiseConv2dNative=function(){return a.asm.w.apply(null,arguments)},a._Div=function(){return a.asm.x.apply(null,arguments)},a._Exp=function(){return a.asm.y.apply(null,arguments)},a._FloorDiv=function(){return a.asm.z.apply(null,arguments)},a._FusedBatchNorm=function(){return a.asm.A.apply(null,arguments)},a._FusedConv2D=function(){return a.asm.B.apply(null,arguments)},a._FusedDepthwiseConv2D=function(){return a.asm.C.apply(null,arguments)},a._Gather=function(){return a.asm.D.apply(null,arguments)},a._GatherNd=function(){return a.asm.E.apply(null,arguments)},a._Greater=function(){return a.asm.F.apply(null,arguments)},a._GreaterEqual=function(){return a.asm.G.apply(null,arguments)},a._Less=function(){return a.asm.H.apply(null,arguments)},a._LessEqual=function(){return a.asm.I.apply(null,arguments)},a._Log=function(){return a.asm.J.apply(null,arguments)},a._LogicalAnd=function(){return a.asm.K.apply(null,arguments)},a._Max=function(){return a.asm.L.apply(null,arguments)},a._MaxPool=function(){return a.asm.M.apply(null,arguments)},a._Maximum=function(){return a.asm.N.apply(null,arguments)},a._Min=function(){return a.asm.O.apply(null,arguments)},a._Minimum=function(){return a.asm.P.apply(null,arguments)},a._Mul=function(){return a.asm.Q.apply(null,arguments)},a._Neg=function(){return a.asm.R.apply(null,arguments)},a._NonMaxSuppressionV3=function(){return a.asm.S.apply(null,arguments)},a._NonMaxSuppressionV5=function(){return a.asm.T.apply(null,arguments)},a._NotEqual=function(){return a.asm.U.apply(null,arguments)},a._PadV2=function(){return a.asm.V.apply(null,arguments)},a._Pow=function(){return a.asm.W.apply(null,arguments)},a._Prelu=function(){return a.asm.X.apply(null,arguments)},a._Relu=function(){return a.asm.Y.apply(null,arguments)},a._Relu6=function(){return a.asm.Z.apply(null,arguments)},a._ResizeBilinear=function(){return a.asm._.apply(null,arguments)},a._Rsqrt=function(){return a.asm.$.apply(null,arguments)},a._ScatterNd=function(){return a.asm.aa.apply(null,arguments)},a._Sigmoid=function(){return a.asm.ba.apply(null,arguments)},a._Sin=function(){return a.asm.ca.apply(null,arguments)},a._Softmax=function(){return a.asm.da.apply(null,arguments)},a._Square=function(){return a.asm.ea.apply(null,arguments)},a._Sub=function(){return a.asm.fa.apply(null,arguments)},a._Sum=function(){return a.asm.ga.apply(null,arguments)},a._Tanh=function(){return a.asm.ha.apply(null,arguments)},a._Tile=function(){return a.asm.ia.apply(null,arguments)},a._Transpose=function(){return a.asm.ja.apply(null,arguments)},a.__FusedMatMul=function(){return a.asm.ka.apply(null,arguments)},a._malloc=function(){return a.asm.la.apply(null,arguments)},a._free=function(){return a.asm.ma.apply(null,arguments)},a.stackSave=function(){return a.asm.na.apply(null,arguments)}),_e=a.stackAlloc=function(){return a.asm.oa.apply(null,arguments)},Ee=a.stackRestore=function(){return a.asm.pa.apply(null,arguments)};function Ce(e){this.name="ExitStatus",this.message="Program terminated with exit("+e+")",this.status=e}function Oe(e){function n(){Se||(Se=!0,M||(Z(),Y(),a.onRuntimeInitialized&&a.onRuntimeInitialized(),J()))}te>0||(X(),te>0||(a.setStatus?(a.setStatus("Running..."),setTimeout((function(){setTimeout((function(){a.setStatus("")}),1),n()}),1)):n()))}if(a.dynCall_vi=function(){return a.asm.qa.apply(null,arguments)},a.dynCall_v=function(){return a.asm.ra.apply(null,arguments)},a.asm=ve,a.cwrap=S,a.then=function(e){if(Se)e(a);else{var n=a.onRuntimeInitialized;a.onRuntimeInitialized=function(){n&&n(),e(a)}}return a},re=function e(){Se||Oe(),Se||(re=e)},a.run=Oe,a.preInit)for("function"==typeof a.preInit&&(a.preInit=[a.preInit]);a.preInit.length>0;)a.preInit.pop()();return Oe(),e});e.exports=a}));class Y extends o{constructor(e){super(),this.wasm=e,this.dataIdNextNumber=1,this.wasm.tfjs.init(),this.dataIdMap=new i(this,d())}write(e,n,t){const a={};return this.move(a,e,n,t),a}numDataIds(){return this.dataIdMap.numDataIds()}async time(e){const t=n.now();return e(),{kernelMs:n.now()-t}}move(e,t,a,r){const u=this.dataIdNextNumber++;if("string"===r){const n=t;return void this.dataIdMap.set(e,{id:u,stringBytes:n,shape:a,dtype:r,memoryOffset:null})}const s=n.sizeFromShape(a),o=s*n.bytesPerElement(r),i=this.wasm._malloc(o);this.dataIdMap.set(e,{id:u,memoryOffset:i,shape:a,dtype:r}),this.wasm.tfjs.registerTensor(u,s,i),null!=t&&this.wasm.HEAPU8.set(new Uint8Array(t.buffer,0,o),i)}async read(e){return this.readSync(e)}readSync(e){const{memoryOffset:t,dtype:a,shape:r,stringBytes:u}=this.dataIdMap.get(e);return"string"===a?u:function(e,n){switch(n){case"float32":return new Float32Array(e);case"int32":return new Int32Array(e);case"bool":return new Uint8Array(e);default:throw new Error(`Unknown dtype ${n}`)}}(this.wasm.HEAPU8.slice(t,t+n.sizeFromShape(r)*n.bytesPerElement(a)).buffer,a)}disposeData(e){const n=this.dataIdMap.get(e);this.wasm._free(n.memoryOffset),this.wasm.tfjs.disposeData(n.id),this.dataIdMap.delete(e)}floatPrecision(){return 32}getMemoryOffset(e){return this.dataIdMap.get(e).memoryOffset}dispose(){this.wasm.tfjs.dispose(),this.wasm=null}memory(){return{unreliable:!1}}makeOutput(e,t,a){let r;if(null==a)r=this.write(null,e,t);else{r={};const u=this.dataIdNextNumber++;this.dataIdMap.set(r,{id:u,memoryOffset:a,shape:e,dtype:t});const s=n.sizeFromShape(e);this.wasm.tfjs.registerTensor(u,s,a)}return{dataId:r,shape:e,dtype:t}}typedArrayFromHeap({shape:e,dtype:t,dataId:a}){const r=this.wasm.HEAPU8.buffer,{memoryOffset:u}=this.dataIdMap.get(a),s=n.sizeFromShape(e);switch(t){case"float32":return new Float32Array(r,u,s);case"int32":return new Int32Array(r,u,s);case"bool":return new Uint8Array(r,u,s);default:throw new Error(`Uknown dtype ${t}`)}}}p("wasm",async()=>{const{wasm:e}=await async function(){return new Promise((e,t)=>{const a={};null!=J&&(a.locateFile=(e,n)=>e.endsWith(".wasm")?J:n+e,Q&&(a.instantiateWasm=function(e){return(t,a)=>(n.fetch(e,{credentials:"same-origin"}).then(n=>{n.ok||t.env.a(`failed to load wasm binary file at '${e}'`),n.arrayBuffer().then(e=>{WebAssembly.instantiate(e,t).then(e=>{a(e.instance)})})}),{})}(J)));const r=Z(a);r.tfjs={init:r.cwrap("init",null,[]),registerTensor:r.cwrap("register_tensor",null,["number","number","number"]),disposeData:r.cwrap("dispose_data",null,["number"]),dispose:r.cwrap("dispose",null,[])};let u=!1;r.onRuntimeInitialized=()=>{u=!0,K=!1,e({wasm:r})},r.onAbort=()=>{if(u)return;if(K)return;K=!0;t({message:"Make sure the server can serve the `.wasm` file relative to the bundled js file. For more details see https://github.com/tensorflow/tfjs/blob/master/tfjs-backend-wasm/README.md#using-bundlers"})}})}();return new Y(e)},2);let J=null,K=!1,Q=!1;function ee(e,n=!1){if(K)throw new Error("The WASM backend was already initialized. Make sure you call `setWasmPath()` before you call `tf.setBackend()` or `tf.ready()`");J=e,Q=n}const ne="2.0.0-rc.3";export{Y as BackendWasm,ee as setWasmPath,ne as version_wasm};
//# sourceMappingURL=tf-backend-wasm.esm.js.map
