/**
 * @license
 * Copyright 2020 Google LLC. All Rights Reserved.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * =============================================================================
 */
!function(e,n){"object"==typeof exports&&"undefined"!=typeof module?n(exports,require("@tensorflow/tfjs-core"),require("fs"),require("path")):"function"==typeof define&&define.amd?define(["exports","@tensorflow/tfjs-core","fs","path"],n):n(((e=e||self).tf=e.tf||{},e.tf.wasm=e.tf.wasm||{}),e.tf,e.fs,e.path)}(this,(function(e,n,t,a){"use strict";var r,u;let s;function i(e){let t;n.registerKernel({kernelName:e,backendName:"wasm",setupFunc:function(n){t=n.wasm.cwrap(e,null,["number","number"])},kernelFunc:function(e){const{backend:a,inputs:{x:r}}=e,u=a.dataIdMap.get(r.dataId).id,s=a.makeOutput(r.shape,r.dtype),i=a.dataIdMap.get(s.dataId).id;return 0===n.util.sizeFromShape(s.shape)?s:(t(u,i),s)}})}function o(e,t,a){let u;n.registerKernel({kernelName:e,backendName:"wasm",setupFunc:function(n){u=n.wasm.cwrap(e,null,["number","array","number","number","array","number","number","number"])},kernelFunc:function(s){const{backend:i,inputs:o}=s,{a:d,b:l}=o,p=i.dataIdMap.get(d.dataId).id,c=i.dataIdMap.get(l.dataId).id,m=null!=a?a:d.dtype,f=n.backend_util.assertAndGetBroadcastShape(d.shape,l.shape),b=i.makeOutput(f,m);if(0===n.util.sizeFromShape(f))return b;const h=new Uint8Array(new Int32Array(d.shape).buffer),y=new Uint8Array(new Int32Array(l.shape).buffer),w=i.dataIdMap.get(b.dataId).id,g=()=>u(p,h,d.shape.length,c,y,l.shape.length,r[d.dtype],w);if(t)return g(),b;const I=n.backend_util.getBroadcastDims(d.shape,f),k=n.backend_util.getBroadcastDims(l.shape,f),M=I.every((e,n)=>e===n),F=k.every((e,n)=>e===n);if(M&&F)return g(),b;throw new Error("Broadcasting along outer dims is not yet "+`supported for ${e}.`)}})}t=t&&t.hasOwnProperty("default")?t.default:t,a=a&&a.hasOwnProperty("default")?a.default:a,function(e){e[e.float32=0]="float32",e[e.int32=1]="int32",e[e.bool=2]="bool",e[e.string=3]="string",e[e.complex64=4]="complex64"}(r||(r={})),function(e){e[e.linear=0]="linear",e[e.relu=1]="relu",e[e.relu6=2]="relu6",e[e.prelu=3]="prelu"}(u||(u={})),n.registerKernel({kernelName:"_FusedMatMul",backendName:"wasm",setupFunc:function(e){s=e.wasm.cwrap("_FusedMatMul",null,["number","array","number","number","array","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{inputs:n,backend:t,attrs:a}=e,{a:r,b:i,bias:o,preluActivationWeights:d}=n;if("float32"!==r.dtype||"float32"!==i.dtype)throw new Error("_FusedMatMul for non non-float32 tensors not yet supported.");const{transposeA:l,transposeB:p,activation:c}=a,m=t.dataIdMap.get(r.dataId).id,f=t.dataIdMap.get(i.dataId).id;let b=0;if(null!=o){const e=t.dataIdMap.get(o.dataId);if(1!==e.shape.length)throw new Error("_FusedMatMul only supports rank-1 bias but got "+`rank ${e.shape.length}.`);b=e.id}const h=null==d?0:t.dataIdMap.get(d.dataId).id,y=u[c];if(null==y)throw new Error(`${c} activation not yet supported for FusedConv2D `+"in the wasm backend.");const w=l?r.shape[2]:r.shape[1],g=p?i.shape[1]:i.shape[2],I=r.shape[0],k=t.makeOutput([I,w,g],r.dtype),M=t.dataIdMap.get(k.dataId).id,F=new Uint8Array(new Int32Array(r.shape).buffer),A=new Uint8Array(new Int32Array(i.shape).buffer);return s(m,F,r.shape.length,f,A,i.shape.length,l,p,y,b,h,M),k}}),i("Abs");let d,l,p,c,m,f;function b(e){const{inputs:{x:n},attrs:{dtype:t},backend:a}=e,r=a.makeOutput(n.shape,t),u=a.typedArrayFromHeap(n);return a.typedArrayFromHeap(r).set(u),r}var h;let y,w;o("Add",!0),n.registerKernel({kernelName:"AddN",backendName:"wasm",setupFunc:function(e){d=e.wasm.cwrap("AddN",null,["array","number","number","number"])},kernelFunc:function(e){const{inputs:t,backend:a}=e,u=a.makeOutput(t[0].shape,t[0].dtype);if(0===n.util.sizeFromShape(u.shape))return u;const s=t.map(e=>a.dataIdMap.get(e.dataId).id),i=new Uint8Array(new Int32Array(s).buffer),o=a.dataIdMap.get(u.dataId).id;return d(i,s.length,r[u.dtype],o),u}}),n.registerKernel({kernelName:"ArgMax",backendName:"wasm",kernelFunc:function(e){const{inputs:{x:t},backend:a,attrs:{axis:u}}=e,s=t.shape.slice(0,-1),i=a.makeOutput(s,"int32"),o=a.dataIdMap.get(t.dataId).id,d=a.dataIdMap.get(i.dataId).id,p=n.util.sizeFromShape(i.shape),c=t.shape[u];return l(o,r[t.dtype],p,c,d),i},setupFunc:function(e){l=e.wasm.cwrap("ArgMax",null,["number","number","number","number","number"])}}),n.registerKernel({kernelName:"AvgPool",backendName:"wasm",setupFunc:function(e){p=e.wasm.cwrap("AvgPool",null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{inputs:n,attrs:t,backend:a}=e,r=t,{x:u}=n,s=a.dataIdMap.get(u.dataId).id,i=r.filterHeight,o=r.filterWidth,d=r.padInfo.top,l=r.padInfo.right,c=r.padInfo.bottom,m=r.padInfo.left,f=r.strideHeight,b=r.strideWidth,h=r.inChannels;if("channelsLast"!==r.dataFormat)throw new Error("wasm backend does not support dataFormat:'"+`${r.dataFormat}'. Please use 'channelsLast'.`);if(1!==r.dilationWidth||1!==r.dilationHeight)throw new Error("was backend only supports average pooling with dilation = [1, 1], "+`got [${r.dilationHeight}, ${r.dilationWidth}].`);const y=a.makeOutput(r.outShape,"float32"),w=a.dataIdMap.get(y.dataId).id;return p(s,u.shape[0],u.shape[1],u.shape[2],i,o,d,l,c,m,f,b,h,w),y}}),n.registerKernel({kernelName:"BatchMatMul",backendName:"wasm",setupFunc:function(e){c=e.wasm.cwrap("BatchMatMul",null,["number","array","number","number","array","number","number","number","number"])},kernelFunc:function(e){const{inputs:n,backend:t,attrs:a}=e,{a:r,b:u}=n;if("float32"!==r.dtype||"float32"!==u.dtype)throw new Error("BatchMatMul for non non-float32 tensors not yet supported.");const{transposeA:s,transposeB:i}=a,o=t.dataIdMap.get(r.dataId).id,d=t.dataIdMap.get(u.dataId).id,l=s?r.shape[2]:r.shape[1],p=i?u.shape[1]:u.shape[2],m=r.shape[0],f=t.makeOutput([m,l,p],r.dtype),b=t.dataIdMap.get(f.dataId).id,h=new Uint8Array(new Int32Array(r.shape).buffer),y=new Uint8Array(new Int32Array(u.shape).buffer);return c(o,h,r.shape.length,d,y,u.shape.length,s,i,b),f}}),n.registerKernel({kernelName:"Cast",backendName:"wasm",kernelFunc:b}),n.registerKernel({kernelName:"ClipByValue",backendName:"wasm",setupFunc:function(e){m=e.wasm.cwrap("ClipByValue",null,["number","number","number","number"])},kernelFunc:function(e){const{inputs:n,backend:t,attrs:a}=e,{x:r}=n,{min:u,max:s}=a,i=t.dataIdMap.get(r.dataId).id,o=t.makeOutput(r.shape,"float32"),d=t.dataIdMap.get(o.dataId).id;return m(i,u,s,d),o}}),n.registerKernel({kernelName:"Concat",backendName:"wasm",kernelFunc:function(e){const{inputs:t,backend:a,attrs:{axis:r}}=e,u=n.backend_util.computeOutShape(t.map(e=>e.shape),r),s=a.makeOutput(u,t[0].dtype),i=n.util.sizeFromShape(t[0].shape.slice(0,r));let o=0;const d=t.map(e=>{const t=n.util.sizeFromShape(e.shape.slice(r));return o+=t,t}),l=t.map(e=>a.typedArrayFromHeap(e)),p=a.typedArrayFromHeap(s);for(let e=0;e<i;e++){let n=e*o;for(let t=0;t<l.length;t++){const a=d[t],r=e*a,u=l[t].subarray(r,r+a);p.set(u,n),n+=a}}return s}}),n.registerKernel({kernelName:"Conv2D",backendName:"wasm",setupFunc:function(e){f=e.wasm.cwrap("Conv2D",null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{inputs:n,attrs:t,backend:a}=e,r=t,{x:u,filter:s}=n,i=a.dataIdMap.get(u.dataId).id,o=a.dataIdMap.get(s.dataId).id,d=r.filterHeight,l=r.filterWidth,p=r.padInfo.top,c=r.padInfo.right,m=r.padInfo.bottom,b=r.padInfo.left,h=r.dilationHeight,y=r.dilationWidth,w=r.strideHeight,g=r.strideWidth,I=r.inChannels,k=r.outChannels,M="SAME"===r.padInfo.type?1:0;if("channelsLast"!==r.dataFormat)throw new Error("wasm backend Conv2D does not support dataFormat:'"+`${r.dataFormat}'. Please use 'channelsLast'.`);const F=a.makeOutput(r.outShape,"float32"),A=a.dataIdMap.get(F.dataId).id;return f(i,u.shape[0],u.shape[1],u.shape[2],o,d,l,p,c,m,b,M,h,y,w,g,I,k,A),F}}),i("Cos"),function(e){e[e.bilinear=0]="bilinear",e[e.nearest=1]="nearest"}(h||(h={})),n.registerKernel({kernelName:"CropAndResize",backendName:"wasm",setupFunc:function(e){y=e.wasm.cwrap("CropAndResize",null,["number","number","number","number","array","number","number","number","number","number"])},kernelFunc:function(e){const{backend:n,inputs:t,attrs:a}=e,{method:r,extrapolationValue:u,cropSize:s}=a,{images:i,boxes:o,boxInd:d}=t,l=o.shape[0],[p,c]=s,m=[l,p,c,i.shape[3]];let f,w=n.dataIdMap.get(i.dataId);"float32"!==i.dtype&&(f=b({backend:n,inputs:{x:i},attrs:{dtype:"float32"}}),w=n.dataIdMap.get(f.dataId));const g=w.id,I=n.dataIdMap.get(o.dataId).id,k=n.dataIdMap.get(d.dataId).id,M=n.makeOutput(m,"float32"),F=n.dataIdMap.get(M.dataId).id,A=new Uint8Array(new Int32Array(i.shape).buffer);return y(g,I,k,l,A,p,c,h[r],u,F),null!=f&&n.disposeData(f.dataId),M}}),n.registerKernel({kernelName:"DepthwiseConv2dNative",backendName:"wasm",setupFunc:function(e){w=e.wasm.cwrap("DepthwiseConv2dNative",null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{inputs:n,attrs:t,backend:a}=e,r=t,{x:u,filter:s}=n,i=a.dataIdMap.get(u.dataId).id,o=a.dataIdMap.get(s.dataId).id,d=r.filterHeight,l=r.filterWidth,p=r.padInfo.top,c=r.padInfo.right,m=r.padInfo.bottom,f=r.padInfo.left,b=r.dilationHeight,h=r.dilationWidth,y=r.strideHeight,g=r.strideWidth,I=r.inChannels,k=r.outChannels,M="SAME"===r.padInfo.type?1:0;if("channelsLast"!==r.dataFormat)throw new Error("wasm backend DepthwiseConv2dNative does not support dataFormat:'"+`${r.dataFormat}'. Please use 'channelsLast'.`);const F=a.makeOutput(r.outShape,"float32"),A=a.dataIdMap.get(F.dataId).id;return w(i,u.shape[0],u.shape[1],u.shape[2],o,d,l,p,c,m,f,M,b,h,y,g,I,k,A),F}});o("Div",!1),i("Exp");let g,I,k,M,F;o("FloorDiv",!1),n.registerKernel({kernelName:"FusedBatchNorm",backendName:"wasm",setupFunc:function(e){g=e.wasm.cwrap("FusedBatchNorm",null,["number","number","number","number","number","number","number"])},kernelFunc:function(e){const{backend:t,inputs:a,attrs:r}=e,{varianceEpsilon:u}=r,{x:s,mean:i,variance:o,offset:d,scale:l}=a,p=t.dataIdMap.get(s.dataId).id,c=t.dataIdMap.get(i.dataId).id,m=t.dataIdMap.get(o.dataId).id,f=null!=d?t.dataIdMap.get(d.dataId).id:0,b=null!=l?t.dataIdMap.get(l.dataId).id:0,h=t.makeOutput(s.shape,s.dtype);if(0===n.util.sizeFromShape(s.shape))return h;const y=t.dataIdMap.get(h.dataId).id;return g(p,c,m,f,b,u,y),h}}),n.registerKernel({kernelName:"FusedConv2D",backendName:"wasm",setupFunc:function(e){I=e.wasm.cwrap("FusedConv2D",null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{inputs:n,attrs:t,backend:a}=e,{convInfo:r,activation:s}=t,i=u[s];if(null==i)throw new Error(`${s} activation not yet supported for FusedConv2D `+"in the wasm backend.");const{x:o,filter:d,bias:l,preluActivationWeights:p}=n,c=a.dataIdMap.get(o.dataId).id,m=a.dataIdMap.get(d.dataId).id,f=r.outChannels;let b=0;if(null!=l){const e=a.dataIdMap.get(l.dataId);if(1!==e.shape.length)throw new Error("FusedConv2D only supports rank-1 bias but got "+`rank ${e.shape.length}.`);if(e.shape[0]!==f)throw new Error(`FusedConv2D bias shape (${e.shape}) does not `+`match the number of output channels (${f})`);b=e.id}const h=r.filterHeight,y=r.filterWidth,w=r.padInfo.top,g=r.padInfo.right,k=r.padInfo.bottom,M=r.padInfo.left,F=r.dilationHeight,A=r.dilationWidth,v=r.strideHeight,S=r.strideWidth,N=r.inChannels,x="SAME"===r.padInfo.type?1:0,_=r.batchSize,E=r.inHeight,O=r.inWidth;if("channelsLast"!==r.dataFormat)throw new Error("wasm backend FusedConv2D does not support dataFormat:'"+`${r.dataFormat}'. Please use 'channelsLast'.`);const C=a.makeOutput(r.outShape,"float32"),D=a.dataIdMap.get(C.dataId).id,z=null==p?0:a.dataIdMap.get(p.dataId).id;return I(c,_,E,O,m,h,y,b,w,g,k,M,x,F,A,v,S,N,f,i,z,D),C}}),n.registerKernel({kernelName:"FusedDepthwiseConv2D",backendName:"wasm",setupFunc:function(e){k=e.wasm.cwrap("FusedDepthwiseConv2D",null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{inputs:n,attrs:t,backend:a}=e,{convInfo:r,activation:s}=t,i=u[s];if(null==i)throw new Error(`${s} activation not yet supported for FusedDepthwiseConv2D `+"in the wasm backend.");const{x:o,filter:d,bias:l,preluActivationWeights:p}=n,c=a.dataIdMap.get(o.dataId).id,m=a.dataIdMap.get(d.dataId).id,f=r.outChannels;let b=0;if(null!=l){const e=a.dataIdMap.get(l.dataId);if(1!==e.shape.length)throw new Error("FusedDepthwiseConv2D only supports rank-1 bias but got "+`rank ${e.shape.length}.`);if(e.shape[0]!==f)throw new Error(`FusedDepthwiseConv2D bias shape (${e.shape}) does not `+`match the number of output channels (${f})`);b=e.id}const h=r.filterHeight,y=r.filterWidth,w=r.padInfo.top,g=r.padInfo.right,I=r.padInfo.bottom,M=r.padInfo.left,F=r.dilationHeight,A=r.dilationWidth,v=r.strideHeight,S=r.strideWidth,N=r.inChannels,x="SAME"===r.padInfo.type?1:0,_=r.batchSize,E=r.inHeight,O=r.inWidth;if("channelsLast"!==r.dataFormat)throw new Error("wasm backend FusedDepthwiseConv2D does not support dataFormat:'"+`${r.dataFormat}'. Please use 'channelsLast'.`);const C=a.makeOutput(r.outShape,"float32"),D=a.dataIdMap.get(C.dataId).id,z=null==p?0:a.dataIdMap.get(p.dataId).id;return k(c,_,E,O,m,h,y,b,w,g,I,M,x,F,A,v,S,N,f,i,z,D),C}}),n.registerKernel({kernelName:"Gather",backendName:"wasm",setupFunc:function(e){M=e.wasm.cwrap("Gather",null,["number","number","array","number","number","number","array","number"])},kernelFunc:function(e){const{backend:t,inputs:a,attrs:u}=e,{x:s,indices:i}=a,{axis:o}=u,d=s.shape.slice();d[o]=n.util.sizeFromShape(i.shape);const l=s.shape.length-1,p=t.makeOutput(d,s.dtype);if(0===n.util.sizeFromShape(s.shape))return p;const c=t.dataIdMap.get(s.dataId).id,m=t.dataIdMap.get(i.dataId).id,f=t.dataIdMap.get(p.dataId).id,b=new Uint8Array(new Int32Array(n.util.computeStrides(s.shape)).buffer),h=new Uint8Array(new Int32Array(n.util.computeStrides(d)).buffer);return M(c,r[s.dtype],b,l,m,o,h,f),p}}),n.registerKernel({kernelName:"GatherNd",backendName:"wasm",setupFunc:function(e){F=e.wasm.cwrap("GatherNd",null,["number","number","number","number","number","number","array","number"])},kernelFunc:function(e){const{backend:t,inputs:a}=e,{x:u,indices:s}=a,[i,o,d,l]=n.gather_util.prepareAndValidate(u,s),p=t.makeOutput(i,u.dtype);if(0===o)return p;const c=s.shape,m=c[c.length-1],f=t.dataIdMap.get(u.dataId).id,b=t.dataIdMap.get(s.dataId).id,h=new Uint8Array(new Int32Array(l).buffer),y=t.dataIdMap.get(p.dataId).id;return F(f,r[u.dtype],b,o,m,d,h,y),p}});o("Greater",!1,"bool");o("GreaterEqual",!1,"bool");o("Less",!1,"bool");o("LessEqual",!1,"bool"),i("Log");let A;o("LogicalAnd",!1,"bool"),n.registerKernel({kernelName:"Max",backendName:"wasm",setupFunc:function(e){A=e.wasm.cwrap("Max",null,["number, number, number"])},kernelFunc:function(e){const{backend:t,inputs:a,attrs:r}=e,{axes:u}=r,{x:s}=a,i=t.dataIdMap.get(s.dataId).id;n.backend_util.assertAxesAreInnerMostDims("max",u,s.shape.length);const[o,d]=n.backend_util.computeOutAndReduceShapes(s.shape,u),l=n.util.sizeFromShape(d),p=t.makeOutput(o,s.dtype);if(0===n.util.sizeFromShape(s.shape))return p;const c=t.dataIdMap.get(p.dataId).id;return A(i,l,c),p}});let v,S;o("Maximum",!1),n.registerKernel({kernelName:"MaxPool",backendName:"wasm",setupFunc:function(e){v=e.wasm.cwrap("MaxPool",null,["number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{inputs:n,attrs:t,backend:a}=e,r=t,{x:u}=n,s=a.dataIdMap.get(u.dataId).id,i=r.filterHeight,o=r.filterWidth,d=r.padInfo.top,l=r.padInfo.right,p=r.padInfo.bottom,c=r.padInfo.left,m=r.dilationHeight,f=r.dilationWidth,b=r.strideHeight,h=r.strideWidth,y=r.inChannels,w=r.outChannels;if("channelsLast"!==r.dataFormat)throw new Error("wasm backend does not support dataFormat:'"+`${r.dataFormat}'. Please use 'channelsLast'.`);const g=a.makeOutput(r.outShape,"float32"),I=a.dataIdMap.get(g.dataId).id;return v(s,u.shape[0],u.shape[1],u.shape[2],i,o,d,l,p,c,m,f,b,h,y,w,I),g}}),n.registerKernel({kernelName:"Min",backendName:"wasm",setupFunc:function(e){S=e.wasm.cwrap("Min",null,["number, number, number"])},kernelFunc:function(e){const{backend:t,inputs:a,attrs:r}=e,{axes:u}=r,{x:s}=a,i=t.dataIdMap.get(s.dataId).id;n.backend_util.assertAxesAreInnerMostDims("min",u,s.shape.length);const[o,d]=n.backend_util.computeOutAndReduceShapes(s.shape,u),l=n.util.sizeFromShape(d),p=t.makeOutput(o,s.dtype);if(0===n.util.sizeFromShape(s.shape))return p;const c=t.dataIdMap.get(p.dataId).id;return S(i,l,c),p}});o("Minimum",!1);function N(e,n){const t=new Int32Array(e.wasm.HEAPU8.buffer,n,3),a=t[0],r=t[1],u=t[2];return e.wasm._free(n),{pSelectedIndices:a,selectedSize:r,pSelectedScores:u}}let x,_;o("Mul",!0),i("Neg"),n.registerKernel({kernelName:"NonMaxSuppressionV3",backendName:"wasm",setupFunc:function(e){x=e.wasm.cwrap("NonMaxSuppressionV3","number",["number","number","number","number","number"])},kernelFunc:function(e){const{backend:n,inputs:t,attrs:a}=e,{iouThreshold:r,maxOutputSize:u,scoreThreshold:s}=a,{boxes:i,scores:o}=t,d=n.dataIdMap.get(i.dataId).id,l=n.dataIdMap.get(o.dataId).id,p=x(d,l,u,r,s),{pSelectedIndices:c,selectedSize:m,pSelectedScores:f}=N(n,p);return n.wasm._free(f),n.makeOutput([m],"int32",c)}}),n.registerKernel({kernelName:"NonMaxSuppressionV5",backendName:"wasm",setupFunc:function(e){_=e.wasm.cwrap("NonMaxSuppressionV5","number",["number","number","number","number","number","number"])},kernelFunc:function(e){const{backend:n,inputs:t,attrs:a}=e,{iouThreshold:r,maxOutputSize:u,scoreThreshold:s,softNmsSigma:i}=a,{boxes:o,scores:d}=t,l=n.dataIdMap.get(o.dataId).id,p=n.dataIdMap.get(d.dataId).id,c=_(l,p,u,r,s,i),{pSelectedIndices:m,selectedSize:f,pSelectedScores:b}=N(n,c);return[n.makeOutput([f],"int32",m),n.makeOutput([f],"float32",b)]}});let E;o("NotEqual",!1,"bool"),n.registerKernel({kernelName:"OnesLike",backendName:"wasm",kernelFunc:function(e){const{inputs:{x:n},backend:t}=e,a=t.makeOutput(n.shape,n.dtype);return t.typedArrayFromHeap(a).fill(1),a}}),n.registerKernel({kernelName:"PadV2",backendName:"wasm",kernelFunc:function(e){const{inputs:{x:n},backend:t,attrs:{paddings:a,constantValue:u}}=e,s=a.map((e,t)=>e[0]+n.shape[t]+e[1]),i=t.dataIdMap.get(n.dataId).id,o=t.makeOutput(s,n.dtype),d=t.dataIdMap.get(o.dataId).id,l=new Uint8Array(new Int32Array(n.shape).buffer),p=[].concat(...a),c=new Uint8Array(new Int32Array(p).buffer);return E(i,l,n.shape.length,r[n.dtype],c,u,d),o},setupFunc:function(e){E=e.wasm.cwrap("PadV2",null,["number","array","number","number","array","number","number"])}});let O,C,D,z,R;function P(e){const{inputs:{x:t},attrs:{begin:a,size:r},backend:u}=e,s=n.slice_util.isSliceContinous(t.shape,a,r),i=u.typedArrayFromHeap(t),o=u.makeOutput(r,t.dtype),d=u.typedArrayFromHeap(o),l=n.util.computeStrides(t.shape);if(s){const e=n.slice_util.computeFlatOffset(a,l);return d.set(i.subarray(e,e+n.util.sizeFromShape(r))),o}const p=t.shape.length;return 2===p?function(e,n,t,a,r){let u=0;const s=a[0],i=a[1],o=s+r[0];for(let a=s;a<o;a++){const s=a*n+i;t.set(e.subarray(s,s+r[1]),u),u+=r[1]}}(i,l[0],d,a,r):3===p?function(e,n,t,a,r,u){let s=0;const i=r[0],o=r[1],d=r[2],l=i+u[0],p=o+u[1];for(let r=i;r<l;r++)for(let i=o;i<p;i++){const o=r*n+i*t+d;a.set(e.subarray(o,o+u[2]),s),s+=u[2]}}(i,l[0],l[1],d,a,r):4===p?function(e,n,t,a,r,u,s){let i=0;const o=u[0],d=u[1],l=u[2],p=o+s[0],c=d+s[1],m=l+s[2],f=u[3];for(let u=o;u<p;u++)for(let o=d;o<c;o++)for(let d=l;d<m;d++){const l=u*n+o*t+d*a+f;r.set(e.subarray(l,l+s[3]),i),i+=s[3]}}(i,l[0],l[1],l[2],d,a,r):function(e,t,a,r,u){const s=n.buffer(u,t.dtype,a),i=n.buffer(t.shape,t.dtype,e);for(let e=0;e<s.size;++e){const n=s.indexToLoc(e).map((e,n)=>e+r[n]);a[e]=i.get(...n)}}(i,t,d,a,r),o}o("Pow",!1),n.registerKernel({kernelName:"Prelu",backendName:"wasm",setupFunc:function(e){O=e.wasm.cwrap("Prelu",null,["number","number","number"])},kernelFunc:function(e){const{inputs:n,backend:t}=e,{x:a,alpha:r}=n,u=t.dataIdMap.get(a.dataId).id,s=t.dataIdMap.get(r.dataId).id,i=t.makeOutput(a.shape,"float32"),o=t.dataIdMap.get(i.dataId).id;return O(u,s,o),i}}),i("Relu"),i("Relu6"),n.registerKernel({kernelName:"Reshape",backendName:"wasm",kernelFunc:function(e){const{inputs:{x:n},attrs:{shape:t}}=e;return{dataId:n.dataId,shape:t,dtype:n.dtype}}}),n.registerKernel({kernelName:"ResizeBilinear",backendName:"wasm",setupFunc:function(e){C=e.wasm.cwrap("ResizeBilinear",null,["number","number","number","number","number","number","number","number","number"])},kernelFunc:function(e){const{backend:t,inputs:a,attrs:r}=e,{x:u}=a,{alignCorners:s,newHeight:i,newWidth:o}=r,[d,l,p,c]=u.shape,m=[d,i,o,c];let f,h=t.dataIdMap.get(u.dataId);"float32"!==h.dtype&&(f=b({backend:t,inputs:{x:u},attrs:{dtype:"float32"}}),h=t.dataIdMap.get(f.dataId));const y=h.id,w=t.makeOutput(m,"float32");if(0===n.util.sizeFromShape(u.shape))return w;const g=t.dataIdMap.get(w.dataId).id;return C(y,d,l,p,c,i,o,s?1:0,g),null!=f&&t.disposeData(f.dataId),w}}),i("Rsqrt"),n.registerKernel({kernelName:"ScatterNd",backendName:"wasm",setupFunc:function(e){D=e.wasm.cwrap("ScatterNd",null,["number","number","number","number","number","number","array","number","number"])},kernelFunc:function(e){const{backend:t,inputs:a,attrs:u}=e,{indices:s,updates:i}=a,{shape:o}=u,d=t.makeOutput(o,i.dtype);if(0===n.util.sizeFromShape(o))return d;const{sliceRank:l,numUpdates:p,sliceSize:c,strides:m,outputSize:f}=n.scatter_util.calculateShapes(i,s,o),b=t.dataIdMap.get(s.dataId).id,h=t.dataIdMap.get(i.dataId).id,y=new Uint8Array(new Int32Array(m).buffer),w=t.dataIdMap.get(d.dataId).id;return D(b,h,r[i.dtype],l,p,c,y,f,w),d}}),n.registerKernel({kernelName:"Sigmoid",backendName:"wasm",setupFunc:function(e){z=e.wasm.cwrap("Sigmoid",null,["number","number"])},kernelFunc:function(e){const{backend:t,inputs:{x:a}}=e,r=t.dataIdMap.get(a.dataId).id,u=t.makeOutput(a.shape,a.dtype),s=t.dataIdMap.get(u.dataId).id;return 0===n.util.sizeFromShape(u.shape)?u:(z(r,s),u)}}),i("Sin"),n.registerKernel({kernelName:"Slice",backendName:"wasm",kernelFunc:P}),n.registerKernel({kernelName:"Softmax",backendName:"wasm",setupFunc:function(e){R=e.wasm.cwrap("Softmax",null,["number","number","number","number"])},kernelFunc:function(e){const{backend:t,inputs:{logits:a},attrs:{dim:r}}=e,u=t.dataIdMap.get(a.dataId).id,s=t.makeOutput(a.shape,a.dtype),i=t.dataIdMap.get(s.dataId).id,o=a.shape[r],d=n.util.sizeFromShape(a.shape)/o;return 0===n.util.sizeFromShape(s.shape)?s:(R(u,i,o,d),s)}}),i("Square");let H,W,U;o("Sub",!0),n.registerKernel({kernelName:"Sum",backendName:"wasm",setupFunc:function(e){H=e.wasm.cwrap("Sum",null,["number, number, number"])},kernelFunc:function(e){const{backend:t,inputs:a,attrs:r}=e,{axes:u}=r,{x:s}=a,i=t.dataIdMap.get(s.dataId).id;n.backend_util.assertAxesAreInnerMostDims("sum",u,s.shape.length);const[o,d]=n.backend_util.computeOutAndReduceShapes(s.shape,u),l=n.util.sizeFromShape(d),p=t.makeOutput(o,s.dtype);if(0===n.util.sizeFromShape(s.shape))return p;const c=t.dataIdMap.get(p.dataId).id;return H(i,l,c),p}}),i("Tanh"),n.registerKernel({kernelName:"Tile",backendName:"wasm",setupFunc:function(e){W=e.wasm.cwrap("Tile",null,["number","array","number","array","number","number"])},kernelFunc:function(e){const{inputs:n,backend:t,attrs:a}=e,{x:u}=n,s=t.dataIdMap.get(u.dataId).id,{reps:i}=a,o=new Array(u.shape.length);for(let e=0;e<o.length;e++)o[e]=u.shape[e]*i[e];const d=new Uint8Array(new Int32Array(u.shape).buffer),l=new Uint8Array(new Int32Array(o).buffer),p=t.makeOutput(o,u.dtype),c=t.dataIdMap.get(p.dataId).id;return W(s,d,u.shape.length,l,o.length,r[p.dtype],c),p}}),n.registerKernel({kernelName:"Transpose",backendName:"wasm",kernelFunc:function(e){const{inputs:n,backend:t,attrs:a}=e,[u,s]=function(e,n){const t=[],a=[];for(let r=0;r<e.length;++r)1!==e[r]&&t.push(e[r]),1!==e[n[r]]&&a.push(n[r]);for(let e=0;e<a.length;++e){let n=-1;for(let t=0;t<a.length;++t)a[t]>=e&&(-1===n||a[n]>a[t])&&(n=t);a[n]=e}return[t,a]}(n.x.shape,a.perm),i={dataId:n.x.dataId,shape:u,dtype:n.x.dtype};let o=!0;for(let e=0;e<s.length;e++)s[e]!==e&&(o=!1);const d=function(e,n){const t=new Array(e.length);for(let a=0;a<t.length;a++)t[a]=e[n[a]];return t}(n.x.shape,a.perm);if(o)return{dataId:i.dataId,shape:d,dtype:i.dtype};const l=t.makeOutput(d,i.dtype),p=t.dataIdMap.get(i.dataId).id,c=t.dataIdMap.get(l.dataId).id,m=new Uint8Array(new Int32Array(s).buffer),f=new Uint8Array(new Int32Array(i.shape).buffer);return U(p,f,i.shape.length,r[i.dtype],c,m,s.length),l},setupFunc:function(e){U=e.wasm.cwrap("Transpose",null,["number","array","number","number","number","array","number"])}}),n.registerKernel({kernelName:"Unpack",backendName:"wasm",kernelFunc:function(e){const{inputs:{x:n},backend:t,attrs:{axis:a}}=e,r=n.shape[a],u=n.shape.length,s=new Array(u-1);let i=0;for(let e=0;e<u;e++)e!==a&&(s[i++]=n.shape[e]);const o=new Array(r),d=new Array(u).fill(0),l=n.shape.slice();l[a]=1;for(let e=0;e<o.length;e++)d[a]=e,o[e]=P({inputs:{x:n},attrs:{begin:d,size:l},backend:t});return o.map(({dataId:e,dtype:n})=>({dataId:e,dtype:n,shape:s}))}}),n.registerKernel({kernelName:"ZerosLike",backendName:"wasm",kernelFunc:function(e){const{inputs:{x:n},backend:t}=e,a=t.makeOutput(n.shape,n.dtype);return t.typedArrayFromHeap(a).fill(0),a}});var K=function(e,n){return e(n={exports:{}},n.exports),n.exports}((function(e,n){var r,u=(r="undefined"!=typeof document&&document.currentScript?document.currentScript.src:void 0,function(e){var n,u=void 0!==(e=e||{})?e:{},s={};for(n in u)u.hasOwnProperty(n)&&(s[n]=u[n]);var i=!1,o=!1,d=!1,l=!1;i="object"==typeof window,o="function"==typeof importScripts,d="object"==typeof process&&"object"==typeof process.versions&&"string"==typeof process.versions.node&&!i&&!o,l=!i&&!d&&!o;var p,c,m,f,b="";function h(e){return u.locateFile?u.locateFile(e,b):b+e}d?(b=__dirname+"/",p=function(e,n){var r;return m||(m=t),f||(f=a),e=f.normalize(e),r=m.readFileSync(e),n?r:r.toString()},c=function(e){var n=p(e,!0);return n.buffer||(n=new Uint8Array(n)),F(n.buffer),n},process.argv.length>1&&process.argv[1].replace(/\\/g,"/"),process.argv.slice(2),process.on("uncaughtException",(function(e){if(!(e instanceof Oe))throw e})),process.on("unhandledRejection",ie),u.inspect=function(){return"[Emscripten Module object]"}):l?("undefined"!=typeof read&&(p=function(e){return read(e)}),c=function(e){var n;return"function"==typeof readbuffer?new Uint8Array(readbuffer(e)):(F("object"==typeof(n=read(e,"binary"))),n)},"undefined"!=typeof scriptArgs&&scriptArgs,"undefined"!=typeof print&&("undefined"==typeof console&&(console={}),console.log=print,console.warn=console.error="undefined"!=typeof printErr?printErr:print)):(i||o)&&(o?b=self.location.href:document.currentScript&&(b=document.currentScript.src),r&&(b=r),b=0!==b.indexOf("blob:")?b.substr(0,b.lastIndexOf("/")+1):"",p=function(e){var n=new XMLHttpRequest;return n.open("GET",e,!1),n.send(null),n.responseText},o&&(c=function(e){var n=new XMLHttpRequest;return n.open("GET",e,!1),n.responseType="arraybuffer",n.send(null),new Uint8Array(n.response)}));var y,w,g=u.print||console.log.bind(console),I=u.printErr||console.warn.bind(console);for(n in s)s.hasOwnProperty(n)&&(u[n]=s[n]);s=null,u.arguments&&u.arguments,u.thisProgram&&u.thisProgram,u.quit&&u.quit,u.wasmBinary&&(y=u.wasmBinary),u.noExitRuntime&&u.noExitRuntime,"object"!=typeof WebAssembly&&I("no native wasm support detected");var k=new WebAssembly.Table({initial:112,maximum:112,element:"anyfunc"}),M=!1;function F(e,n){e||ie("Assertion failed: "+n)}function A(e){var n=u["_"+e];return F(n,"Cannot call unknown function "+e+", make sure it is exported"),n}function v(e,n,t,a,r){var u={string:function(e){var n=0;if(null!=e&&0!==e){var t=1+(e.length<<2);O(e,n=_e(t),t)}return n},array:function(e){var n=_e(e.length);return C(e,n),n}},s=A(e),i=[],o=0;if(a)for(var d=0;d<a.length;d++){var l=u[t[d]];l?(0===o&&(o=xe()),i[d]=l(a[d])):i[d]=a[d]}var p=s.apply(null,i);return p=function(e){return"string"===n?_(e):"boolean"===n?Boolean(e):e}(p),0!==o&&Ee(o),p}function S(e,n,t,a){var r=(t=t||[]).every((function(e){return"number"===e}));return"string"!==n&&r&&!a?A(e):function(){return v(e,n,t,arguments)}}var N="undefined"!=typeof TextDecoder?new TextDecoder("utf8"):void 0;function x(e,n,t){for(var a=n+t,r=n;e[r]&&!(r>=a);)++r;if(r-n>16&&e.subarray&&N)return N.decode(e.subarray(n,r));for(var u="";n<r;){var s=e[n++];if(128&s){var i=63&e[n++];if(192!=(224&s)){var o=63&e[n++];if((s=224==(240&s)?(15&s)<<12|i<<6|o:(7&s)<<18|i<<12|o<<6|63&e[n++])<65536)u+=String.fromCharCode(s);else{var d=s-65536;u+=String.fromCharCode(55296|d>>10,56320|1023&d)}}else u+=String.fromCharCode((31&s)<<6|i)}else u+=String.fromCharCode(s)}return u}function _(e,n){return e?x(R,e,n):""}function E(e,n,t,a){if(!(a>0))return 0;for(var r=t,u=t+a-1,s=0;s<e.length;++s){var i=e.charCodeAt(s);if(i>=55296&&i<=57343&&(i=65536+((1023&i)<<10)|1023&e.charCodeAt(++s)),i<=127){if(t>=u)break;n[t++]=i}else if(i<=2047){if(t+1>=u)break;n[t++]=192|i>>6,n[t++]=128|63&i}else if(i<=65535){if(t+2>=u)break;n[t++]=224|i>>12,n[t++]=128|i>>6&63,n[t++]=128|63&i}else{if(t+3>=u)break;n[t++]=240|i>>18,n[t++]=128|i>>12&63,n[t++]=128|i>>6&63,n[t++]=128|63&i}}return n[t]=0,t-r}function O(e,n,t){return E(e,R,n,t)}function C(e,n){z.set(e,n)}"undefined"!=typeof TextDecoder&&new TextDecoder("utf-16le");var D,z,R,P,H=65536;function W(e,n){return e%n>0&&(e+=n-e%n),e}function U(e){D=e,u.HEAP8=z=new Int8Array(e),u.HEAP16=new Int16Array(e),u.HEAP32=P=new Int32Array(e),u.HEAPU8=R=new Uint8Array(e),u.HEAPU16=new Uint16Array(e),u.HEAPU32=new Uint32Array(e),u.HEAPF32=new Float32Array(e),u.HEAPF64=new Float64Array(e)}var K=5253200,B=10160,T=u.TOTAL_MEMORY||16777216;function L(e){for(;e.length>0;){var n=e.shift();if("function"!=typeof n){var t=n.func;"number"==typeof t?void 0===n.arg?u.dynCall_v(t):u.dynCall_vi(t,n.arg):t(void 0===n.arg?null:n.arg)}else n()}}(w=u.wasmMemory?u.wasmMemory:new WebAssembly.Memory({initial:T/H}))&&(D=w.buffer),T=D.byteLength,U(D),P[B>>2]=K;var j=[],$=[],q=[],V=[];function G(){if(u.preRun)for("function"==typeof u.preRun&&(u.preRun=[u.preRun]);u.preRun.length;)J(u.preRun.shift());L(j)}function X(){L($)}function Z(){L(q)}function Y(){if(u.postRun)for("function"==typeof u.postRun&&(u.postRun=[u.postRun]);u.postRun.length;)Q(u.postRun.shift());L(V)}function J(e){j.unshift(e)}function Q(e){V.unshift(e)}var ee=Math.ceil,ne=Math.floor,te=0,ae=null,re=null;function ue(e){te++,u.monitorRunDependencies&&u.monitorRunDependencies(te)}function se(e){if(te--,u.monitorRunDependencies&&u.monitorRunDependencies(te),0==te&&(null!==ae&&(clearInterval(ae),ae=null),re)){var n=re;re=null,n()}}function ie(e){throw u.onAbort&&u.onAbort(e),g(e+=""),I(e),M=!0,e="abort("+e+"). Build with -s ASSERTIONS=1 for more info.",new WebAssembly.RuntimeError(e)}u.preloadedImages={},u.preloadedAudios={};var oe="data:application/octet-stream;base64,";function de(e){return String.prototype.startsWith?e.startsWith(oe):0===e.indexOf(oe)}var le="tfjs-backend-wasm.wasm";function pe(){try{if(y)return new Uint8Array(y);if(c)return c(le);throw"both async and sync fetching of the wasm failed"}catch(e){ie(e)}}function ce(){return y||!i&&!o||"function"!=typeof fetch?new Promise((function(e,n){e(pe())})):fetch(le,{credentials:"same-origin"}).then((function(e){if(!e.ok)throw"failed to load wasm binary file at '"+le+"'";return e.arrayBuffer()})).catch((function(){return pe()}))}function me(){var e={env:Ae,wasi_unstable:Ae};function n(e,n){var t=e.exports;u.asm=t,se()}function t(e){n(e.instance)}function a(n){return ce().then((function(n){return WebAssembly.instantiate(n,e)})).then(n,(function(e){I("failed to asynchronously prepare wasm: "+e),ie(e)}))}if(ue(),u.instantiateWasm)try{return u.instantiateWasm(e,n)}catch(e){return I("Module.instantiateWasm callback failed with error: "+e),!1}return function(){if(y||"function"!=typeof WebAssembly.instantiateStreaming||de(le)||"function"!=typeof fetch)return a(t);fetch(le,{credentials:"same-origin"}).then((function(n){return WebAssembly.instantiateStreaming(n,e).then(t,(function(e){I("wasm streaming compile failed: "+e),I("falling back to ArrayBuffer instantiation"),a(t)}))}))}(),{}}function fe(){ie()}function be(e,n,t){R.set(R.subarray(n,n+t),e)}function he(){return z.length}function ye(e){try{return w.grow(e-D.byteLength+65535>>16),U(w.buffer),1}catch(e){}}function we(e){var n=he();if(e>2147418112)return!1;for(var t=Math.max(n,16777216);t<e;)t=t<=536870912?W(2*t,65536):Math.min(W((3*t+2147483648)/4,65536),2147418112);return!!ye(t)}de(le)||(le=h(le)),$.push({func:function(){Ne()}});var ge={buffers:[null,[],[]],printChar:function(e,n){var t=ge.buffers[e];0===n||10===n?((1===e?g:I)(x(t,0)),t.length=0):t.push(n)},varargs:0,get:function(e){return ge.varargs+=4,P[ge.varargs-4>>2]},getStr:function(){return _(ge.get())},get64:function(){var e=ge.get();return ge.get(),e},getZero:function(){ge.get()}};function Ie(e){try{return 0}catch(e){return"undefined"!=typeof FS&&e instanceof FS.ErrnoError||ie(e),e.errno}}function ke(e,n,t,a,r){try{return 0}catch(e){return"undefined"!=typeof FS&&e instanceof FS.ErrnoError||ie(e),e.errno}}function Me(e,n,t,a){try{for(var r=0,u=0;u<t;u++){for(var s=P[n+8*u>>2],i=P[n+(8*u+4)>>2],o=0;o<i;o++)ge.printChar(e,R[s+o]);r+=i}return P[a>>2]=r,0}catch(e){return"undefined"!=typeof FS&&e instanceof FS.ErrnoError||ie(e),e.errno}}function Fe(e){return(e=+e)>=0?+ne(e+.5):+ee(e-.5)}var Ae={a:fe,d:be,e:we,g:Ie,c:ke,f:Me,memory:w,b:Fe,table:k},ve=me();u.asm=ve;var Se,Ne=u.___wasm_call_ctors=function(){return u.asm.h.apply(null,arguments)},xe=(u._init=function(){return u.asm.i.apply(null,arguments)},u._register_tensor=function(){return u.asm.j.apply(null,arguments)},u._dispose_data=function(){return u.asm.k.apply(null,arguments)},u._dispose=function(){return u.asm.l.apply(null,arguments)},u._Abs=function(){return u.asm.m.apply(null,arguments)},u._Add=function(){return u.asm.n.apply(null,arguments)},u._AddN=function(){return u.asm.o.apply(null,arguments)},u._ArgMax=function(){return u.asm.p.apply(null,arguments)},u._AvgPool=function(){return u.asm.q.apply(null,arguments)},u._BatchMatMul=function(){return u.asm.r.apply(null,arguments)},u._ClipByValue=function(){return u.asm.s.apply(null,arguments)},u._Conv2D=function(){return u.asm.t.apply(null,arguments)},u._Cos=function(){return u.asm.u.apply(null,arguments)},u._CropAndResize=function(){return u.asm.v.apply(null,arguments)},u._DepthwiseConv2dNative=function(){return u.asm.w.apply(null,arguments)},u._Div=function(){return u.asm.x.apply(null,arguments)},u._Exp=function(){return u.asm.y.apply(null,arguments)},u._FloorDiv=function(){return u.asm.z.apply(null,arguments)},u._FusedBatchNorm=function(){return u.asm.A.apply(null,arguments)},u._FusedConv2D=function(){return u.asm.B.apply(null,arguments)},u._FusedDepthwiseConv2D=function(){return u.asm.C.apply(null,arguments)},u._Gather=function(){return u.asm.D.apply(null,arguments)},u._GatherNd=function(){return u.asm.E.apply(null,arguments)},u._Greater=function(){return u.asm.F.apply(null,arguments)},u._GreaterEqual=function(){return u.asm.G.apply(null,arguments)},u._Less=function(){return u.asm.H.apply(null,arguments)},u._LessEqual=function(){return u.asm.I.apply(null,arguments)},u._Log=function(){return u.asm.J.apply(null,arguments)},u._LogicalAnd=function(){return u.asm.K.apply(null,arguments)},u._Max=function(){return u.asm.L.apply(null,arguments)},u._MaxPool=function(){return u.asm.M.apply(null,arguments)},u._Maximum=function(){return u.asm.N.apply(null,arguments)},u._Min=function(){return u.asm.O.apply(null,arguments)},u._Minimum=function(){return u.asm.P.apply(null,arguments)},u._Mul=function(){return u.asm.Q.apply(null,arguments)},u._Neg=function(){return u.asm.R.apply(null,arguments)},u._NonMaxSuppressionV3=function(){return u.asm.S.apply(null,arguments)},u._NonMaxSuppressionV5=function(){return u.asm.T.apply(null,arguments)},u._NotEqual=function(){return u.asm.U.apply(null,arguments)},u._PadV2=function(){return u.asm.V.apply(null,arguments)},u._Pow=function(){return u.asm.W.apply(null,arguments)},u._Prelu=function(){return u.asm.X.apply(null,arguments)},u._Relu=function(){return u.asm.Y.apply(null,arguments)},u._Relu6=function(){return u.asm.Z.apply(null,arguments)},u._ResizeBilinear=function(){return u.asm._.apply(null,arguments)},u._Rsqrt=function(){return u.asm.$.apply(null,arguments)},u._ScatterNd=function(){return u.asm.aa.apply(null,arguments)},u._Sigmoid=function(){return u.asm.ba.apply(null,arguments)},u._Sin=function(){return u.asm.ca.apply(null,arguments)},u._Softmax=function(){return u.asm.da.apply(null,arguments)},u._Square=function(){return u.asm.ea.apply(null,arguments)},u._Sub=function(){return u.asm.fa.apply(null,arguments)},u._Sum=function(){return u.asm.ga.apply(null,arguments)},u._Tanh=function(){return u.asm.ha.apply(null,arguments)},u._Tile=function(){return u.asm.ia.apply(null,arguments)},u._Transpose=function(){return u.asm.ja.apply(null,arguments)},u.__FusedMatMul=function(){return u.asm.ka.apply(null,arguments)},u._malloc=function(){return u.asm.la.apply(null,arguments)},u._free=function(){return u.asm.ma.apply(null,arguments)},u.stackSave=function(){return u.asm.na.apply(null,arguments)}),_e=u.stackAlloc=function(){return u.asm.oa.apply(null,arguments)},Ee=u.stackRestore=function(){return u.asm.pa.apply(null,arguments)};function Oe(e){this.name="ExitStatus",this.message="Program terminated with exit("+e+")",this.status=e}function Ce(e){function n(){Se||(Se=!0,M||(X(),Z(),u.onRuntimeInitialized&&u.onRuntimeInitialized(),Y()))}te>0||(G(),te>0||(u.setStatus?(u.setStatus("Running..."),setTimeout((function(){setTimeout((function(){u.setStatus("")}),1),n()}),1)):n()))}if(u.dynCall_vi=function(){return u.asm.qa.apply(null,arguments)},u.dynCall_v=function(){return u.asm.ra.apply(null,arguments)},u.asm=ve,u.cwrap=S,u.then=function(e){if(Se)e(u);else{var n=u.onRuntimeInitialized;u.onRuntimeInitialized=function(){n&&n(),e(u)}}return u},re=function e(){Se||Ce(),Se||(re=e)},u.run=Ce,u.preInit)for("function"==typeof u.preInit&&(u.preInit=[u.preInit]);u.preInit.length>0;)u.preInit.pop()();return Ce(),e});e.exports=u}));class B extends n.KernelBackend{constructor(e){super(),this.wasm=e,this.dataIdNextNumber=1,this.wasm.tfjs.init(),this.dataIdMap=new n.DataStorage(this,n.engine())}write(e,n,t){const a={};return this.move(a,e,n,t),a}numDataIds(){return this.dataIdMap.numDataIds()}async time(e){const t=n.util.now();return e(),{kernelMs:n.util.now()-t}}move(e,t,a,r){const u=this.dataIdNextNumber++;if("string"===r){const n=t;return void this.dataIdMap.set(e,{id:u,stringBytes:n,shape:a,dtype:r,memoryOffset:null})}const s=n.util.sizeFromShape(a),i=s*n.util.bytesPerElement(r),o=this.wasm._malloc(i);this.dataIdMap.set(e,{id:u,memoryOffset:o,shape:a,dtype:r}),this.wasm.tfjs.registerTensor(u,s,o),null!=t&&this.wasm.HEAPU8.set(new Uint8Array(t.buffer,0,i),o)}async read(e){return this.readSync(e)}readSync(e){const{memoryOffset:t,dtype:a,shape:r,stringBytes:u}=this.dataIdMap.get(e);return"string"===a?u:function(e,n){switch(n){case"float32":return new Float32Array(e);case"int32":return new Int32Array(e);case"bool":return new Uint8Array(e);default:throw new Error(`Unknown dtype ${n}`)}}(this.wasm.HEAPU8.slice(t,t+n.util.sizeFromShape(r)*n.util.bytesPerElement(a)).buffer,a)}disposeData(e){const n=this.dataIdMap.get(e);this.wasm._free(n.memoryOffset),this.wasm.tfjs.disposeData(n.id),this.dataIdMap.delete(e)}floatPrecision(){return 32}getMemoryOffset(e){return this.dataIdMap.get(e).memoryOffset}dispose(){this.wasm.tfjs.dispose(),this.wasm=null}memory(){return{unreliable:!1}}makeOutput(e,t,a){let r;if(null==a)r=this.write(null,e,t);else{r={};const u=this.dataIdNextNumber++;this.dataIdMap.set(r,{id:u,memoryOffset:a,shape:e,dtype:t});const s=n.util.sizeFromShape(e);this.wasm.tfjs.registerTensor(u,s,a)}return{dataId:r,shape:e,dtype:t}}typedArrayFromHeap({shape:e,dtype:t,dataId:a}){const r=this.wasm.HEAPU8.buffer,{memoryOffset:u}=this.dataIdMap.get(a),s=n.util.sizeFromShape(e);switch(t){case"float32":return new Float32Array(r,u,s);case"int32":return new Int32Array(r,u,s);case"bool":return new Uint8Array(r,u,s);default:throw new Error(`Uknown dtype ${t}`)}}}n.registerBackend("wasm",async()=>{const{wasm:e}=await async function(){return new Promise((e,t)=>{const a={};null!=T&&(a.locateFile=(e,n)=>e.endsWith(".wasm")?T:n+e,j&&(a.instantiateWasm=function(e){return(t,a)=>(n.util.fetch(e,{credentials:"same-origin"}).then(n=>{n.ok||t.env.a(`failed to load wasm binary file at '${e}'`),n.arrayBuffer().then(e=>{WebAssembly.instantiate(e,t).then(e=>{a(e.instance)})})}),{})}(T)));const r=K(a);r.tfjs={init:r.cwrap("init",null,[]),registerTensor:r.cwrap("register_tensor",null,["number","number","number"]),disposeData:r.cwrap("dispose_data",null,["number"]),dispose:r.cwrap("dispose",null,[])};let u=!1;r.onRuntimeInitialized=()=>{u=!0,L=!1,e({wasm:r})},r.onAbort=()=>{if(u)return;if(L)return;L=!0;t({message:"Make sure the server can serve the `.wasm` file relative to the bundled js file. For more details see https://github.com/tensorflow/tfjs/blob/master/tfjs-backend-wasm/README.md#using-bundlers"})}})}();return new B(e)},2);let T=null,L=!1,j=!1;e.BackendWasm=B,e.setWasmPath=function(e,n=!1){if(L)throw new Error("The WASM backend was already initialized. Make sure you call `setWasmPath()` before you call `tf.setBackend()` or `tf.ready()`");T=e,j=n},e.version_wasm="2.0.0-rc.3",Object.defineProperty(e,"__esModule",{value:!0})}));
//# sourceMappingURL=tf-backend-wasm.min.js.map
